module mavect
use mkinds
use mconstants
use mstate
use mgrid
use mobs

contains

subroutine set_bv(var,mdepth,bv,fv,spval)
implicit none
integer      :: i,j
character(*) :: var
real(r4)     :: bv(:,:)
real(r4)     :: fv(:,:)
real(r4)     :: mdepth(:,:)
real(r4)     :: spval

! limit the innovations to specified values.
! 
        if(var=="l3ssh" .or. var=="l4ssh" ) then
                where(bv<spval .and. mdepth<spval .and. fv<spval) bv=(bv-fv)
                where(abs(bv)>1.8) bv=spval
        elseif(var=="l3sst") then
                where(bv<spval .and. mdepth<spval .and. fv<spval) bv=(bv-fv)
                where(abs(bv)>25.0) bv=spval
        elseif(var=="l4sst") then
                bv=(bv-fv)
                where(abs(bv)>25.0) bv=spval
        elseif(var=="l2sss") then
                bv=(bv-fv)
                where(abs(bv)>10.0) bv=spval                
        elseif(var=="tem") then
                where(bv<spval .and. mdepth<spval .and. fv<spval) bv=(bv-fv)
                where(abs(bv)>15.0) bv=spval
        elseif (var=="sal") then
                where(bv<spval .and. mdepth<spval .and. fv<spval) bv=(bv-fv)
                where(abs(bv)>10.0) bv=spval
        elseif (var=="pin") then
                where(bv<spval .and. mdepth<spval) bv=(bv-fv)
                where(abs(bv)>300.0) bv=spval

       elseif(var=="vvl" .or. var=="uvl" ) then
                where(bv<spval .and. mdepth<spval .and. fv<spval) bv=(bv-fv)
                where(abs(bv)>3.0) bv=spval

       endif
end subroutine

subroutine getbvev(analysis_date,pfx,var,bv,ev,k)
implicit none
character(len=*)           :: analysis_date
character(len=*)           :: pfx
character(len=*)           :: var
real(r4)                   :: bv(:,:)
real(r4)                   :: ev(:,:)
integer(i4)                :: k
character(:),allocatable   :: obsFile
real(r4)                   :: tmp(nx,ny)


obsFile=trim(tsis_obs_location)//"/tsis_obs_"//pfx//"_"//analysis_date//".nc"

if(var=="l3ssh") then
        print*,'l3ssh' !!Alex
        call nciopn(obsFile,fid)
        call nciorv(obsFile,fid,"l3ssh",bv)
        call nciocl(obsFile,fid)
        print*,'l3ssh done!' !!Alex

        ev=0.04
else if( var=="l3sst") then
        print*,'l3sst' !!Alex
        call nciopn(obsFile,fid)
        call nciorv(obsFile,fid,"l3sst",bv)
        call nciorv(obsFile,fid,"l3sst_err",ev)
        call nciocl(obsFile,fid)
else if( var=="l2sss") then
        call nciopn(obsFile,fid)
        call nciorv(obsFile,fid,"l2sss",bv)
        call nciorv(obsFile,fid,"l2sst_err",ev)
        call nciocl(obsFile,fid)
else if( var=="l4sst") then
        call nciopn(obsFile,fid)
        call nciorv(obsFile,fid,"l4sst",bv)
        call nciorv(obsFile,fid,"l4sst_err",ev)
        call nciocl(obsFile,fid)
        else if( var=="l4ssh") then
        call nciopn(obsFile,fid)
        call nciorv(obsFile,fid,"l4ssh",bv)
        call nciorv(obsFile,fid,"l4ssh_err",ev)
        call nciocl(obsFile,fid)
else if( var=="uvl") then
        call nciopn(obsFile,fid)
        call nciorv(obsFile,fid,"uos",bv)
        call nciocl(obsFile,fid)
        ev=0.1
else if( var=="vvl") then
        call nciopn(obsFile,fid)
        call nciorv(obsFile,fid,"vos",bv)
        call nciocl(obsFile,fid)
        ev=0.1
endif

end subroutine

subroutine pobs2mgrid3(nobs,ivar,ilvl,b3,e3,nvalid)
implicit none
integer(i4)              :: ivar
integer(i4)              :: ilvl
integer(i4)              :: nobs
integer(i4)              :: ncount
integer(i4)              :: nvalid

real(r4)                 :: b3(:,:,:,:)
real(r4)                 :: e3(:,:,:,:)

! local
integer(i4)              :: i,ii,jj,k

b3=spval
ncount=nobs
nvalid=0
do i=1,ncount
 do k=1,nl
  if (profile_lyr_obs(ivar,k,i)%id==1 .and. profile_lyr_obs(ivar,k,i)%qc==1) then
   ii=profile_lyr_obs(ivar,k,i)%grdi
   jj=profile_lyr_obs(ivar,k,i)%grdj
   b3(ii,jj,k,1)=profile_lyr_obs(1,k,i)%val-f3(ii,jj,k,1)
   if(abs(b3(ii,jj,k,1))>5.0) b3(ii,jj,k,1)=spval
     b3(ii,jj,k,2)=profile_lyr_obs(2,k,i)%val-f3(ii,jj,k,2)
   if(abs(b3(ii,jj,k,2))>3.0) b3(ii,jj,k,2)=spval
   b3(ii,jj,k,3)=profile_lyr_obs(4,k,i)%val-f3(ii,jj,k,3)
   if(abs(b3(ii,jj,k,3))>300.0) b3(ii,jj,k,3)=spval

!   print *,ii,jj,b3(ii,jj,k,1),profile_lyr_obs(1,k,i)%inov
!   if(ivar==1) then
        e3(ii,jj,k,1)=max(0.05,profile_lyr_obs(1,k,i)%err)
!   else if(ivar==2) then
        e3(ii,jj,k,2)=max(0.02,profile_lyr_obs(2,k,i)%err)
!   else if(ivar==4) then    
        e3(ii,jj,k,3)=max(10.0,profile_lyr_obs(4,k,i)%err)
!   endif
 
   nvalid=nvalid+1
  endif
 enddo
enddo
 
end subroutine

subroutine init_pobs(analysis_date,nobs,pfx)
implicit none
character(len=*) :: analysis_date
character(len=*) :: pfx
integer(i4),intent(out) :: nobs
character(:),allocatable       :: filename
integer(i4)             :: ncount
integer(i4)             :: nobs_typ
nobs_typ=4
if(allocated(profile_lyr_obs)) deallocate(profile_lyr_obs)
ncount=0
filename=trim(tsis_obs_location)//"/tsis_obs_"//trim(pfx)//"_"//analysis_date//".nc"
call nciopn(filename,fid)
call ncioin(filename,fid,"prof_num",ncount)
allocate(profile_lyr_obs(nobs_typ,nl,ncount))
call nciorv(filename,fid,"lon",profile_lyr_obs%lon)
call nciorv(filename,fid,"lat",profile_lyr_obs%lat)
call nciorv(filename,fid,"val",profile_lyr_obs%val)
!!Alex call nciorv(filename,fid,"inov",profile_lyr_obs%inov)
call nciorv(filename,fid,"err",profile_lyr_obs%err)
call nciorv(filename,fid,"grdi",profile_lyr_obs%grdi)
call nciorv(filename,fid,"grdj",profile_lyr_obs%grdj)
call nciorv(filename,fid,"id",profile_lyr_obs%id)
call nciorv(filename,fid,"qc",profile_lyr_obs%qc)
call nciocl(filename,fid)
nobs=ncount
end subroutine


subroutine sobs2mgrid3(analysis_date,pfx,sb3,se3,mdepth)
implicit none
character(len=*)           :: analysis_date
character(len=*)           :: pfx
real(r4)                   :: sb3(:,:,:,:)
real(r4)                   :: se3(:,:,:,:)
real(r4)                   :: mdepth(:,:)
integer(i4)                :: k
character(:),allocatable   :: obsFile
real(r4)                   :: tmp(nx,ny)


        obsFile=trim(tsis_obs_location)//"/tsis_obs_"//pfx//"_"//analysis_date//".nc"
        call nciopn(obsFile,fid)
        call nciorv(obsFile,fid,"uos",sb3(:,:,1,1))
        call nciorv(obsFile,fid,"vos",sb3(:,:,2,1))
        call nciorv(obsFile,fid,"l3ssh",sb3(:,:,3,1))
        call nciocl(obsFile,fid)

        print *, minval(sb3(:,:,1,1),mask=sb3(:,:,1,1)<spval), minval(sb3(:,:,2,1),mask=sb3(:,:,2,1)<spval),&
        minval(sb3(:,:,3,1),mask=sb3(:,:,3,1)<spval)

       do k=1,3
        where(sb3(:,:,k,1)<spval .and. mdepth<spval .and. sf3(:,:,k,1)<spval) sb3(:,:,k,1)=sb3(:,:,k,1)-sf3(:,:,k,1)
       enddo
       where(abs(sb3(:,:,1:2,1))>2.0) sb3(:,:,1:2,1)=spval
       where(abs(sb3(:,:,3,1))>1.0) sb3(:,:,3,1)=spval        

       sb3(:,:,3,1)=spval


               print *, minval(sb3(:,:,1,1),mask=sb3(:,:,1,1)<spval), minval(sb3(:,:,2,1),mask=sb3(:,:,2,1)<spval),&
        minval(sb3(:,:,3,1),mask=sb3(:,:,3,1)<spval)


end subroutine












end module mavect        
