module mc2r
use mkinds
use mconstants
USE OMP_LIB
use mabio
use mncio
use mstring
use mdates
use mhycom





contains


subroutine rstc2r()

implicit none


integer(i4)                    :: nx,ny,nz,nl,i,j,k,m,iunit,l,nt1,nt2,nstep,baclin,iversn,iexpt,yrflag
integer(i4)                    :: src_nx,src_ny,src_nl,dst_nx,dst_ny,dst_nl
real(r4)                       :: hmin,hmax,thbase

real(r4),allocatable           :: src_psikk(:,:,:),src_thkk(:,:,:),src_pbot(:,:)
real(r4),allocatable           :: src_uvel(:,:,:),src_vvel(:,:,:),src_temp(:,:,:),src_dp(:,:,:),src_saln(:,:,:)
real(r4),allocatable           :: src_ubavg(:,:),src_vbavg(:,:),src_dpmixl(:,:),src_pbavg(:,:)
real(r4),allocatable           :: src_thkice(:,:),src_temice(:,:),src_covice(:,:)

real(r4),allocatable           :: dst_psikk(:,:,:),dst_thkk(:,:,:),dst_pbot(:,:)
real(r4),allocatable           :: dst_uvel(:,:,:),dst_vvel(:,:,:),dst_temp(:,:,:),dst_dp(:,:,:),dst_saln(:,:,:)
real(r4),allocatable           :: dst_ubavg(:,:),dst_vbavg(:,:),dst_dpmixl(:,:),dst_pbavg(:,:)
real(r4),allocatable           :: dst_thkice(:,:),dst_temice(:,:),dst_covice(:,:)

integer(i4),allocatable        :: xmap(:,:)
   integer(i4),allocatable     :: ymap(:,:)
real(r4),allocatable           :: xmin(:),xmax(:)
integer(i4),allocatable        :: xc(:),yc(:),zc(:),tc1(:),tc2(:)
real(r4)                       :: mday
logical                        :: lsteric
character(:),allocatable       :: rstIn,gridFile,rstOut
character(10)                  :: cdtg
integer(i4)                       :: year
integer(i4)                       :: day
character(4)                   :: cyear
character(3)                   :: cday
integer(i4)                    :: stat
character(8)                   :: cmtime
character(cl)                  :: buffer

!call getarg(1,cdtg)
!call cymd2hday(cdtg,mday)
!call hday2ydn(mday, YEAR,DAY)
!call int2str(int(year),cyear,'(i4.4)',stat)
!call int2str(int(day),cday,'(i3.3)',stat)
!call flt2str(mday,cmtime,'(F8.2)',stat)

rstIn="restart_out"
rstOut="restart_outr"


iexpt=10
iversn=22
yrflag=3
lsteric=.true.
baclin=720
src_nx=1500
src_ny=1100
dst_nx=1440
dst_ny=851

nl=32
nt1=2
nt2=3


allocate(xmap(dst_nx,dst_ny))
allocate(ymap(dst_nx,dst_ny))

allocate(src_psikk(src_nx,src_ny,2))
allocate(src_thkk(src_nx,src_ny,2))
allocate(src_pbot(src_nx,src_ny))
allocate(src_uvel(src_nx,src_ny,nl))
allocate(src_vvel(src_nx,src_ny,nl))
allocate(src_temp(src_nx,src_ny,nl))
allocate(src_saln(src_nx,src_ny,nl))
allocate(src_dp(src_nx,src_ny,nl))
allocate(src_ubavg(src_nx,src_ny))
allocate(src_vbavg(src_nx,src_ny))
allocate(src_pbavg(src_nx,src_ny))
allocate(src_dpmixl(src_nx,src_ny))
allocate(src_temice(src_nx,src_ny))
allocate(src_thkice(src_nx,src_ny))
allocate(src_covice(src_nx,src_ny))
allocate(xmin(nl))
allocate(xmax(nl))



allocate(dst_psikk(dst_nx,dst_ny,2))
allocate(dst_thkk(dst_nx,dst_ny,2))
allocate(dst_pbot(dst_nx,dst_ny))
allocate(dst_uvel(dst_nx,dst_ny,nl))
allocate(dst_vvel(dst_nx,dst_ny,nl))
allocate(dst_temp(dst_nx,dst_ny,nl))
allocate(dst_saln(dst_nx,dst_ny,nl))
allocate(dst_dp(dst_nx,dst_ny,nl))
allocate(dst_ubavg(dst_nx,dst_ny))
allocate(dst_vbavg(dst_nx,dst_ny))
allocate(dst_pbavg(dst_nx,dst_ny))
allocate(dst_dpmixl(dst_nx,dst_ny))
allocate(dst_temice(dst_nx,dst_ny))
allocate(dst_thkice(dst_nx,dst_ny))
allocate(dst_covice(dst_nx,dst_ny))





gridFile="gridinfo.nc"
call nciopn(gridFile,fid)
call nciorv(gridFile,fid,"c2rxmap",xmap)
call nciorv(gridFile,fid,"c2rymap",ymap)
call nciocl(gridFile,fid)


iunit=11
! Initialize hycom style IO

CALL zaiost(src_nx,src_ny)
CALL zaiopn(rstIn,iunit)

! read uvel
DO k=1,nl
  CALL zaiosk(iunit)
ENDDO
 do k=1,nl
   CALL zaiord(iunit,src_uvel(:,:,k),hmin,hmax)
 enddo

! read vvel
DO k=1,nl
  CALL zaiosk(iunit)
ENDDO
do k=1,nl
   CALL zaiord(iunit,src_vvel(:,:,k),hmin,hmax)
 enddo

! read dp
DO k=1,nl
  CALL zaiosk(iunit)
ENDDO
do k=1,nl
   CALL zaiord(iunit,src_dp(:,:,k),hmin,hmax)
 enddo  

! read temp
DO k=1,nl
  CALL zaiosk(iunit)
ENDDO
do k=1,nl
   CALL zaiord(iunit,src_temp(:,:,k),hmin,hmax)
 enddo

! read saln
DO k=1,nl
  CALL zaiosk(iunit)
ENDDO
do k=1,nl
   CALL zaiord(iunit,src_saln(:,:,k),hmin,hmax)
 enddo

! read ubavg
CALL zaiosk(iunit)
   CALL zaiord(iunit,src_ubavg(:,:),hmin,hmax)
CALL zaiosk(iunit)

! read vbavg
CALL zaiosk(iunit)
   CALL zaiord(iunit,src_vbavg(:,:),hmin,hmax)
CALL zaiosk(iunit)

! read pbavg
CALL zaiosk(iunit)
   CALL zaiord(iunit,src_pbavg(:,:),hmin,hmax)
CALL zaiosk(iunit)

! read pbot
CALL zaiord(iunit,src_pbot(:,:),hmin,hmax)

! read psikk
CALL zaiord(iunit,src_psikk(:,:,1),hmin,hmax)
CALL zaiord(iunit,src_psikk(:,:,2),hmin,hmax)


! read thkk
CALL zaiord(iunit,src_thkk(:,:,1),hmin,hmax)
CALL zaiord(iunit,src_thkk(:,:,2),hmin,hmax)


! read dpmixl
CALL zaiosk(iunit)
CALL zaiord(iunit,src_dpmixl(:,:),hmin,hmax)


! read temice
CALL zaiord(iunit,src_temice(:,:),hmin,hmax)

! read thkice
CALL zaiord(iunit,src_covice(:,:),hmin,hmax)

! read covice
CALL zaiord(iunit,src_thkice(:,:),hmin,hmax)

! close file
call zaiocl(iunit)


do k=1,nl
  do j=1,dst_ny
     do i=1,dst_nx
        dst_uvel(i,j,k)=src_uvel(xmap(i,j),ymap(i,j),k)
        dst_vvel(i,j,k)=src_vvel(xmap(i,j),ymap(i,j),k)
        dst_dp(i,j,k)=src_dp(xmap(i,j),ymap(i,j),k)
        dst_temp(i,j,k)=src_temp(xmap(i,j),ymap(i,j),k)
        dst_saln(i,j,k)=src_saln(xmap(i,j),ymap(i,j),k)
     enddo
   enddo
enddo

   do j=1,dst_ny
     do i=1,dst_nx
        dst_pbot(i,j)=src_pbot(xmap(i,j),ymap(i,j))
        dst_thkk(i,j,1)=src_thkk(xmap(i,j),ymap(i,j),1)
        dst_thkk(i,j,2)=src_thkk(xmap(i,j),ymap(i,j),2)
        dst_psikk(i,j,1)=src_psikk(xmap(i,j),ymap(i,j),1)
        dst_psikk(i,j,2)=src_psikk(xmap(i,j),ymap(i,j),2)
        dst_pbavg(i,j)=src_pbavg(xmap(i,j),ymap(i,j))
        dst_dpmixl(i,j)=src_dpmixl(xmap(i,j),ymap(i,j))
        dst_ubavg(i,j)=src_ubavg(xmap(i,j),ymap(i,j))
        dst_vbavg(i,j)=src_vbavg(xmap(i,j),ymap(i,j))
        dst_temice(i,j)=src_temice(xmap(i,j),ymap(i,j))
        dst_covice(i,j)=src_covice(xmap(i,j),ymap(i,j))
        dst_thkice(i,j)=src_thkice(xmap(i,j),ymap(i,j))
     enddo
   enddo





call writerst(dst_nx,dst_ny,nl,4,2,.false.,34.0,mday,&
                dst_uvel,dst_vvel,dst_temp,dst_saln,dst_dp,&
                dst_ubavg,dst_vbavg,dst_pbavg,dst_pbot,dst_psikk,dst_thkk,dst_dpmixl)










stop



end subroutine    

subroutine r2cxi(FileName,nx,ny,nl,mlon,mlat,mlayer,rdepth,rssh,ruvl,rvvl,rthk,rtem,rsal)
use mkinds
use mncio

implicit none

character(*)              :: Filename
character(:),allocatable  :: fname
integer(i4)               :: nx,ny,nl


integer(i4),parameter     :: cnx=1500,cny=1100
integer(i4),allocatable   :: xx(:),yy(:)
real(r4)                  :: mlon(nx,ny),mlat(nx,ny),mlayer(nl),rdepth(nx,ny)

real(r4)                  :: rssh(nx,ny)
real(r4)                  :: ruvl(nx,ny,nl)
real(r4)                  :: rvvl(nx,ny,nl)
real(r4)                  :: rtem(nx,ny,nl)
real(r4)                  :: rsal(nx,ny,nl)
real(r4)                  :: rthk(nx,ny,nl)

real(r4),allocatable      :: clat(:,:),clon(:,:),cdepth(:,:)
real(r4),allocatable      :: cssh(:,:)
real(r4),allocatable      :: cuvl(:,:,:)
real(r4),allocatable      :: cvvl(:,:,:)
real(r4),allocatable      :: ctem(:,:,:)
real(r4),allocatable      :: csal(:,:,:)
real(r4),allocatable      :: cthk(:,:,:)
real(r4),allocatable      :: r2cxmap(:,:,:),r2cymap(:,:,:),r2cwgts(:,:,:)
real(r4),parameter        :: spval=2.00**100
integer(i4)               :: i,j,k
real(r4)                  :: ip,jp
real(r4)                  :: ptlon,ptlat

allocate(xx(cnx))
allocate(yy(cny))
allocate(r2cxmap(cnx,cny,4))
allocate(r2cymap(cnx,cny,4))
allocate(r2cwgts(cnx,cny,4))

allocate(clat(nx,ny))
allocate(clon(nx,ny))
allocate(cdepth(nx,ny))
allocate(cssh(cnx,cny))
allocate(cuvl(cnx,cny,nl))
allocate(cvvl(cnx,cny,nl))
allocate(ctem(cnx,cny,nl))
allocate(csal(cnx,cny,nl))
allocate(cthk(cnx,cny,nl))


fname="gridinfo.nc"
call nciopn(fname,fid)
call nciorv(fname,fid,"r2cxmap",r2cxmap)
call nciorv(fname,fid,"r2cymap",r2cymap)
call nciorv(fname,fid,"r2cwgts",r2cwgts)
call nciocl(fname,fid)


do j=1,cny
 do i=1,cnx
cssh(i,j)=rssh(r2cxmap(i,j,1),r2cymap(i,j,1))*r2cwgts(i,j,1)+rssh(r2cxmap(i,j,2),r2cymap(i,j,2))*r2cwgts(i,j,2) &
          +rssh(r2cxmap(i,j,3),r2cymap(i,j,3))*r2cwgts(i,j,3)+rssh(r2cxmap(i,j,4),r2cymap(i,j,4))*r2cwgts(i,j,4)
 enddo
enddo

!$OMP parallel do schedule(static) private(k,j,i) collapse(1)
do k=1,nl
 do j=1,cny
  do i=11,cnx
  cuvl(i,j,k)=ruvl(r2cxmap(i,j,1),r2cymap(i,j,1),k)*r2cwgts(i,j,1)+ruvl(r2cxmap(i,j,2),r2cymap(i,j,2),k)*r2cwgts(i,j,2) &
          +ruvl(r2cxmap(i,j,3),r2cymap(i,j,3),k)*r2cwgts(i,j,3)+ruvl(r2cxmap(i,j,4),r2cymap(i,j,4),k)*r2cwgts(i,j,4)

 cvvl(i,j,k)=rvvl(r2cxmap(i,j,1),r2cymap(i,j,1),k)*r2cwgts(i,j,1)+rvvl(r2cxmap(i,j,2),r2cymap(i,j,2),k)*r2cwgts(i,j,2) &
          +rvvl(r2cxmap(i,j,3),r2cymap(i,j,3),k)*r2cwgts(i,j,3)+rvvl(r2cxmap(i,j,4),r2cymap(i,j,4),k)*r2cwgts(i,j,4)

  ctem(i,j,k)=rtem(r2cxmap(i,j,1),r2cymap(i,j,1),k)*r2cwgts(i,j,1)+rtem(r2cxmap(i,j,2),r2cymap(i,j,2),k)*r2cwgts(i,j,2) &
          +rtem(r2cxmap(i,j,3),r2cymap(i,j,3),k)*r2cwgts(i,j,3)+rtem(r2cxmap(i,j,4),r2cymap(i,j,4),k)*r2cwgts(i,j,4)

  csal(i,j,k)=rsal(r2cxmap(i,j,1),r2cymap(i,j,1),k)*r2cwgts(i,j,1)+rsal(r2cxmap(i,j,2),r2cymap(i,j,2),k)*r2cwgts(i,j,2) &
          +rsal(r2cxmap(i,j,3),r2cymap(i,j,3),k)*r2cwgts(i,j,3)+rsal(r2cxmap(i,j,4),r2cymap(i,j,4),k)*r2cwgts(i,j,4)

  cthk(i,j,k)=rthk(r2cxmap(i,j,1),r2cymap(i,j,1),k)*r2cwgts(i,j,1)+rthk(r2cxmap(i,j,2),r2cymap(i,j,2),k)*r2cwgts(i,j,2) &
          +rthk(r2cxmap(i,j,3),r2cymap(i,j,3),k)*r2cwgts(i,j,3)+rthk(r2cxmap(i,j,4),r2cymap(i,j,4),k)*r2cwgts(i,j,4)
  enddo
 enddo
enddo

!$OMP End Parallel do

 where(abs(ctem(1180:1300,660:720,25:32))>0.2) ctem(1180:1300,660:720,25:32)=0.0
 call writeHYCOMXI(FileName,cnx,cny,nl,clon,clat,mlayer,cdepth,cssh,cuvl,cvvl,cthk,ctem,csal)

!FileName="analysis_grid_check.nc"
!call nciocf(filename,fid)
!create dimension and coordinate variable 1
!vname="xax"
!vtype=NF90_FLOAT
!vdim1d(1)=1
!call nciodd(filename,fid,vname,cnx)
!call nciocv(filename,fid,vname,vtype,vdim1d)

!create dimension and coordinate variable 2

!vname="yax"
!vtype=NF90_Float
!vdim1d(1)=2
!call nciodd(filename,fid,vname,cny)
!call nciocv(filename,fid,vname,vtype,vdim1d)

!create data variable 1
!vname="cssh"
!vtype=NF90_Float
!vdim2d=(/1,2/)
!call nciocv(filename,fid,vname,vtype,vdim2d)
!call nciowa(filename,fid,vname,'_FillValue',spval)
!call nciowa(filename,fid,vname,'standard_name','surface_elevation')
!call nciowa(filename,fid,vname,'units','m')
!call ncioed(filename,fid)

!call nciowv(filename,fid,"xax",xx)
!call nciowv(filename,fid,"yax",yy)
!call nciowv(filename,fid,"cssh",cssh)


!call nciocl(filename,fid)


end subroutine


end module
