module mdrifter
use mkinds
use mconstants
use mncio
use mdates
use mobs

integer(i4)                    :: n_drifter
real(r4),allocatable           :: drifter_lon(:)
real(r4),allocatable           :: drifter_lat(:)
real(r4),allocatable           :: drifter_uc(:)
real(r4),allocatable           :: drifter_vc(:)
real(r8),allocatable           :: drifter_time(:)

contains


        subroutine drifter_2cobs(cdate,iflag)

  implicit none


  character(*)                 :: cdate
  character(10)                :: cdate_hh
  character(10)                :: cdate_w 
  character(:),allocatable     :: inFile
  logical(bl)                  :: lexist

  character(11)                :: drifter_date
  character(8)                 :: cdrifter_time
  integer(i4)                  :: nlimit,year,month,day,hr,mn,ntd,nd,ihour,nvalid,nrocis
  real(r4)                     :: mtime,stime
  real(r4)                     :: plon,plat,ud,vd
  integer(i4)                  :: i,j,k
  integer(i4)                  :: ix,jy
  integer(i4)                  :: twin
  integer(i4)                  :: iflag

  call read_obs_location()
  inFile=trim(drifter_data_location)//cdate(1:4)//"/buoys_"//cdate(1:4)//".txt"
  inquire (file=inFile,exist=lexist)

  if(lexist) then
  call cymd2hday(cdate,mtime)
  cdate_hh=cdate//"00"
  open(unit=20,file=inFile,status="unknown")
  ntd=0
  nvalid=0
  do
    read(20,*,end=20) drifter_date,cdrifter_time,stime
    call cm2nm(drifter_date,cdate_w)
    call cymd2hday(cdate_w,stime)
    read(cdrifter_time(1:2), '(i2)' ) ihour
    stime=stime+ihour/24.0
    ntd=ntd+1
    if(stime>=mtime .and. stime<mtime+1.0) then
    nvalid=nvalid+1
    !Write(*,'(i4,2x,a11,2x,a2,2x,2F10.2)') ntd,drifter_date,drifter_time(1:2),mtime,stime
  endif
  enddo
20 continue
  close(20)

allocate(drifter_time(nvalid))
allocate(drifter_lon(nvalid))
allocate(drifter_lat(nvalid))
allocate(drifter_uc(nvalid))
allocate(drifter_vc(nvalid))


open(unit=20,file=inFile,status="old")
nvalid=0
do i=1,ntd
   read(20,*,end=40) drifter_date,cdrifter_time,stime,plon,plat,ud,vd,plon,plat,ud,vd
   call cm2nm(drifter_date,cdate_w)
   call cymd2hday(cdate_w,stime)
   read(cdrifter_time(1:2), '(i2)' ) ihour
   stime=stime+ihour/24.0
   ntd=ntd+1
   if(stime>=mtime .and. stime<mtime+1.0) then
      nvalid=nvalid+1
      drifter_time(nvalid)=stime
      drifter_lon(nvalid)=plon
      drifter_lat(nvalid)=plat
      drifter_uc(nvalid)=ud
      drifter_vc(nvalid)=vd
   endif
enddo
40 continue
close(20)


n_drifter=nvalid
write(*,*) "....Total Number of L2 Drifter Velocities: .... ", nvalid

if(n_drifter>0) then
        iflag=0
else
        iflag=-1
endif

else ! no drifter files

        iflag=-1
        write(*,*) "....no L2 drifter velocities:...."

endif



end subroutine

subroutine dumpDrifters(cdate,ndays)
        implicit none
  character(*)                 :: cdate
  character(10)                :: cdate_hh
  character(10)                :: cdate_w
  character(:),allocatable     :: inFile
  logical(bl)                  :: lexist

  character(11)                :: drifter_date
  character(8)                 :: cdrifter_time
  integer(i4)                  :: nlimit,year,month,day,hr,mn,ntd,nd,ihour,nvalid,nrocis
  real(r4)                     :: mtime,stime
  real(r4)                     :: plon,plat,ud,vd
  integer(i4)                  :: i,j,k
  integer(i4)                  :: ix,jy
  integer(i4)                  :: twin
  integer(i4)                  :: iflag
  integer(i4)                  :: ndays

  call read_obs_location()
  inFile=trim(drifter_data_location)//cdate(1:4)//"/buoys_"//cdate(1:4)//".txt"
  inquire (file=inFile,exist=lexist)

  if(lexist) then
  call cymd2hday(cdate,mtime)
  cdate_hh=cdate//"00"
  open(unit=20,file=inFile,status="unknown")
  ntd=0
  nvalid=0
  do
    read(20,*,end=20) drifter_date,cdrifter_time,stime,plon,plat,ud,vd
    call cm2nm(drifter_date,cdate_w)
    call cymd2hday(cdate_w,stime)
    read(cdrifter_time(1:2), '(i2)' ) ihour
    stime=stime+ihour/24.0
    if(stime>=mtime .and. stime<mtime+ndays) then
            if(plon>=lnmn .and. plon<lnmx .and. plat>=ltmn .and. plat<ltmx) then
    ntd=ntd+1
    Write(*,'(i9,2x,a11,2x,a2,2x,6F10.2)') ntd,drifter_date,cdrifter_time(1:2),mtime,stime,plon,plat,ud,vd
  endif
  endif
  enddo
20 continue
  close(20)

  endif

        end subroutine


end module




