module minit

use mkinds
use mconstants
use mgrid
use mglobals
use mstate
use mspmd
use mdates
use mminfo
use msstat
use mobs


contains

subroutine initialize_tsis()
implicit none

integer(i4)               :: k
integer(i4)               :: nob_grp
logical(bl)               :: lexist
integer(i4),allocatable               :: ob_grp_present(:)

!initialize analysis grid first for spmd processing

call initialize_analysis_grid()
call start_spmd()
call spmd_distribute()

!call set analysis date
call set_analysis_date()
call set_model_info()
call initialize_obs()
call read_stats_location()
call init_stat(analysis_date,pfx)

! check obs and stats files

!cobsFile=trim(cobs_location)//"/"//analysis_date(1:4)//"/tsis_cobs_"//analysis_date//".nc"
!INQUIRE(FILE=cobsFile, EXIST=lexist)
! IF(lexist) then
!   IF(PID==0) THEN
!     write(*,*) "....cobs file is .... " ,cobsFile
!!   ENDIF
! ELSE
!         write(*,*) "....no cobs file ....",cobsFile
!         write(*,*) "....stop ...."
!         stop
!         call stop_spmd()
!         IF(PID==0) write(*,*) "....no obs file ....",obsFile
!         IF(PID==0) write(*,*) "....stop ...."
!         stop
!ENDIF

tsis_stat_file=trim(tsis_stat_location)//"tops_"//trim(pfx)//"_stats.nc"

INQUIRE(FILE=tsis_stat_file, EXIST=lexist)
 IF(lexist) then
   IF(PID==0) THEN
            write(*,*) "....stats file is .... " ,"tops_"//trim(pfx)//"_stats.nc"
   ENDIF
 ELSE
         call stop_spmd()
         IF(PID==0) write(*,*) "....no stats file ...."
         IF(PID==0) write(*,*) "....stop ...."
          write(*,*) "....no stats file ...."
          stop
ENDIF


! allocate states
call malloc_state(start,count)
call malloc_avectors(start,count)
inquire(file=XFCFileName,exist=lexist)
            if(lexist .and. mr==1) then
              write(*,*) "....forecast file is ...." , XFCFileName
              call nciopn(XFCFileName,fid)
              call nciorv(XFCFileName,fid,"cdepth",mdepth)
              call nciorv(XFCFileName,fid,"ssh",fssh)
              call nciorv(XFCFileName,fid,"mld",fmld)
              call nciorv(XFCFileName,fid,"tem",ftem)
              call nciorv(XFCFileName,fid,"sal",fsal)
              call nciorv(XFCFileName,fid,"thk",fthk)
              call nciorv(XFCFileName,fid,"uvl",fuvl)
              call nciorv(XFCFileName,fid,"vvl",fvvl)
              call nciorv(XFCFileName,fid,"den",fden)
              call nciorv(XFCFileName,fid,"msk3d",mskmr)
              call nciocl(XFCFileName,fid)
              msk3d=mskmr
              where(mskmr==0) fthk=0.0
!              call update_pin(fthk,fpin)
              fsss=fsal(:,:,1)
              fsst=ftem(:,:,1)
              !call update_den(ftem,fsal)
      Else
INQUIRE(FILE=FCFileName//".a", EXIST=lexist)
 IF(lexist) then
         IF(PID==0) THEN
            write(*,*) "....forecast file is ...." ,  FCFileName
            call getFCstate(FCFileName,fcmodel,c2r)
         ENDIF
ELSE
         call stop_spmd()
         IF(PID==0) write(*,*) "....no forecast file ...."
         stop
ENDIF


ENDIF ! 

obsFile=trim(tsis_obs_location)//"/tsis_obs_"//trim(pfx)//"_"//analysis_date//".nc"
call nciopn(obsFile,fid)
!call ncioin(obsFile,fid,"nobgrp",nob_grp)
!allocate(ob_grp_present(nob_grp))
call nciorv(obsFile,fid,"obsgrp",obsgrp)
call nciocl(obsFile,fid)

 l2profile=.false.
 l2sst=.false.
 l2sss=.false.
 l2uv=.false.
 l3sla=.false.
 l3sst=.false.
 l4sla=.false.
 l4sst=.false.
 l4uv=.false.


!1. l2_tsprofiles,
!2. l2_uvprofiles,
!3. l2_sst,
!4. l2_sss,
!5. l2_suv,
!6. l3_sla,
!7. l3_sst
!8. l4_sla,
!9. l4_sst,
!10.l4_suv,
!11.l2_swot_sla,    





            if(obsgrp(1)==1) l2profile=.true.
            if(obsgrp(3)==1) l2sst=.true.
            if(obsgrp(4)==1) l2sss=.true.
            if(obsgrp(5)==1) l2uv=.true.
            if(obsgrp(6)==1) l3sla=.true.
            if(obsgrp(7)==1) l3sst=.true.
            if(obsgrp(8)==1) l4sla=.true.
            if(obsgrp(9)==1) l4sst=.true.
            if(obsgrp(10)==1) l4uv=.true.

IF(PID==0) THEN
            write(*,*) "....loaded forecast state...."
            write(*,*) "....grid dimensions ...." , nx,ny,nl
            write(*,*) "....eqn of state ...." , sigver
            write(*,*) "....no of processing elements ...." , npes
            write(*,*) "....average size of subdivided domain ...." ,nx,(jlp-jfp)
            write(*,*) "....Profile available ...." , l2profile
            write(*,*) "....L3 SLA available ...." , l3sla
            write(*,*) "....L4 SLA available ....",l4sla
            write(*,*) "....L3 SST available ....",l3sst
            write(*,*) "....L4 SST available ....",l4sst
            write(*,*) "....L2 SST available ....",l2sst
            write(*,*) "....L2 SSS available ....",l2sss
            write(*,*) "....L2 UV available ....",l2uv
 
            write(*,*) "....initialization complete...."
ENDIF
call spmd_wait()

end subroutine initialize_tsis



end module minit

