module miquam
use mkinds
use mdates
use mncio
use mobs

real(r4),allocatable      :: l2isst_lon(:)
real(r4),allocatable      :: l2isst_lat(:)
real(r4),allocatable      :: l2isst_val(:)
real(r8),allocatable      :: l2isst_time(:)
real(r4),allocatable      :: l2isst_err(:)
integer(i4),parameter     :: nmx=5000000
integer(i4)               :: nl2isst


contains


subroutine iquam_l2isst_2cobs(cdate,iflag)

implicit none


character(10)             :: cdate
logical(bl)               :: lexist
integer(i4)               :: twin_start
integer(i4)               :: twin_end
integer(i4)               :: ncount
integer(i4)               :: i,j,ii,jj
character(:),allocatable  :: iquamFile
character(:),allocatable  :: fname
integer(i4)               :: iflag
real(r4)                   :: wday
integer(i4) ,allocatable               :: iqtime(:)
real(r8) ,allocatable                  :: iqsst(:)
real(r4) ,allocatable                  :: iqlon(:)
real(r4) ,allocatable                  :: iqlat(:)
integer(i4),allocatable               :: iqqcf(:)
integer(i4),allocatable               :: iyr(:)
integer(i4),allocatable               :: imm(:)
integer(i4),allocatable               :: idd(:)
integer(i4),allocatable               :: ihr(:)
character(10)                          :: wanted_date
character(10)                          :: obs_date
integer(i4)               :: nvalid

call cymd2hday(cdate,wday)
call hday2cymd(wday,wanted_date) 

iquamFile=trim(l2i_sst_location)//"/"//cdate(1:4)//"/iquam_l2i_"//cdate(1:6)//"xx.nc"
inquire(file=iquamFile,exist=lexist)

if(lexist) then
 call nciopn(iquamFile,fid)
 call ncioin(iquamFile,fid,"obs",ncount)

 allocate(iqlon(ncount))
 allocate(iqlat(ncount))
 allocate(iqtime(ncount))
 allocate(iqsst(ncount))
 allocate(iqqcf(ncount))
 allocate(iyr(ncount))
 allocate(imm(ncount))
 allocate(idd(ncount))
 allocate(ihr(ncount))

 call nciorv(iquamFile,fid,"lon",iqlon)
 call nciorv(iquamFile,fid,"lat",iqlat)
 call nciorv(iquamFile,fid,"time",iqtime)
 call nciorv(iquamFile,fid,"sst",iqsst)
 call nciorv(iquamFile,fid,"quality_level",iqqcf)
 call nciorv(iquamFile,fid,"year",iyr)
 call nciorv(iquamFile,fid,"month",imm)
 call nciorv(iquamFile,fid,"day",idd)
 call nciorv(iquamFile,fid,"hour",ihr)
 call nciocl(iquamFile,fid)
nvalid=0
 do i=1,ncount
        write(obs_date(1:4),'(i4.4)')  iyr(i)
        write(obs_date(5:6),'(i2.2)')  imm(i)
        write(obs_date(7:8),'(i2.2)')  idd(i)
        write(obs_date(9:10),'(i2.2)')  ihr(i)
   if(iqqcf(i)>4 .and. obs_date(1:8)==wanted_date(1:8)) then
           nvalid=nvalid+1
  
   endif
 enddo

 allocate(l2isst_lon(nvalid))
 allocate(l2isst_lat(nvalid))
 allocate(l2isst_time(nvalid))
 allocate(l2isst_val(nvalid))
 allocate(l2isst_err(nvalid))

 if(nvalid>0) write(*,*) "....L2i SST FILE....", iquamFile

nvalid=0
 do i=1,ncount
        write(obs_date(1:4),'(i4.4)')  iyr(i)
        write(obs_date(5:6),'(i2.2)')  imm(i)
        write(obs_date(7:8),'(i2.2)')  idd(i)
        write(obs_date(9:10),'(i2.2)')  ihr(i)
   if(iqqcf(i)>4 .and. obs_date(1:8)==wanted_date(1:8)) then
   nvalid=nvalid+1
   l2isst_lon(nvalid)=iqlon(i)
   l2isst_lat(nvalid)=iqlat(i)
   l2isst_val(nvalid)=iqsst(i)-273.15
   l2isst_err(nvalid)=0.1
   l2isst_time(nvalid)=real(wday,r8)+real(ihr(i),r8)/24.0
   endif
   enddo
nl2isst=nvalid
   if(nvalid>0) then
           iflag=0
Write(*,*) "....Total no of L2i SST observations points: ",nl2isst
 deallocate(iqlon)
 deallocate(iqlat)
 deallocate(iqtime)
 deallocate(iqsst)
 deallocate(iqqcf)
 deallocate(iyr)
 deallocate(imm)
 deallocate(idd)
 deallocate(ihr)
        
else
        iflag=-1
        write(*,*) "....no L2i SST...."
endif

else


iflag=-1
write(*,*) "....L2i SST file not present...."
endif

end subroutine






end module miquam      
