module mlilo
use mkinds
use mconstants
use mseawater

contains

SUBROUTINE lilo(start,count,mdepth,thref,thbase,dp0k,dpin,th3d,dpmixl,deltassh,dpout)

implicit none

INTEGER(i4)         :: start(3)
INTEGER(i4)         :: count(3)

!integer(i4)         :: mask2d(count(1),count(2))
REAL(r4)            :: mdepth(count(1),count(2))
!REAL(r4)            :: ists(count(1),count(2))
real(r4),intent(in)            :: dpin(count(1),count(2),count(3))
real(r4),intent(in)            :: th3d(count(1),count(2),count(3))
real(r4),intent(in)            :: deltassh(count(1),count(2))
real(r4),intent(in)            :: dpmixl(count(1),count(2))
real(r4)            :: dpout(count(1),count(2),count(3))
real(r4)            :: dp0k(count(3))
real(r4)            :: cdepth
real(r4)            :: thbase
real(r4)            :: thref
real(r4)            :: dlim
! Local variables

integer(i4)         :: i,j,k,k0,kk,kmn,kmx,err,fid
integer(i4)         :: k2,kk2,kml,kmn2,kmx2

real(r4)            :: ddp(count(1),count(2),count(3))
real(r4)            :: pin(count(1),count(2),count(3)+1)
!real(r4)            :: dp0k(count(3))
integer(i4)         :: called(count(1),count(2))
integer(i4)         :: error(count(1),count(2))

real(r4)            :: dz1d,dzout
real(r4)            :: den1d(count(3))
real(r4)            :: dpmin1d(count(3))
real(r4)            :: dp1d(count(3))
real(r4)            :: ddp1d(count(3))

real(r4)            :: den1d2(count(3))
real(r4)            :: dpmin1d2(count(3))
real(r4)            :: dp1d2(count(3))
real(r4)            :: ddp1d2(count(3))


!real(r4),parameter  :: flag=2.00**100,onem=9806.0,qonem = 1.0/9806.,g =9.806
real(r4)            :: smin,smax,sumdp,fract

kk=count(3)

!convert to pressure units
dp0k=dp0k*onem
dpout=dpin

!calculate interface pressures and density
pin(:,:,1)=0.0
do k=1,kk
   pin(:,:,k+1)= pin(:,:,k)+dpin(:,:,k)
enddo

!loop for CH

DO j= 1,count(2)
 DO i= 1,count(1)
     called(i,j)=0.
     error(i,j)=1
! Adjust only if depth is greater than critical depth
!     if(abs(deltassh(i,j)) > 0.02 .and. ists(i,j)>0.0 ) then
!     if (mask2d(i,j) .eq. 1 .and.mdepth(i,j).gt. cdepth)then

! all layers beneath and including the layer containing the mixed layer base
! will be adjusted if necessary. To extend the adjustment into all fixed thickness layers at and beneath the
! mixed layer base, all layers between the layer containing the base (kml) and
! the first layer significantly thicker than the specified minimum thickness
! (kmn) are consolidated into a single layer before the call to ch. After the
! ch call, all layers within this consolidated layer are thinned or thickened
! in the same proportion as the consolidated layer. k0 is set to 4 to exclude layers 1-3 from adjustment because they are
! assumed to always be in the mixed layer.

!if(j<300 .or. j>700) then
!    k0=10
!else
    k0=4
!endif

    kml=k0
    do k=k0,kk
        if(pin(i,j,k).gt.dpmixl(i,j)*onem)then
           kml=k
           exit
        endif
     enddo

    kmn=k
 
    do k=k0,kk
       if(dpin(i,j,k).gt.dp0k(k)+onem)then
          kmn=k
          exit
       endif
    enddo
   kml=min(kml,kmn)

    kmx=kmn

    do k=kk,kmn,-1
       if(dpin(i,j,k).ge.onem.and.dpin(i,j,k).gt.dp0k(k) .and. pin(i,j,k).lt.mdepth(i,j)*onem) then
         kmx=k
         exit
       endif
    enddo


    do k=1,kk
        dz1d=deltassh(i,j)
        den1d(k)=(1.0/thref)/(1.0-thref*(th3d(i,j,k)))
        dpmin1d(k)=min(dpin(i,j,k),dp0k(k)) !in pressure unit
        dp1d(k)=dpin(i,j,k)  !in pressure units
    enddo

! consolidate layers from kml to kmn so that minimum thickness layers are also
! adjusted

    kk2=kk-kmn+kml
    kmn2=kml
    kmx2=kmx+kk2-kk

    den1d2=0.0
    dpmin1d2=0.0
    dp1d2=0.0
    ddp1d2=0.0

    do k=1,kk2
       if (k<kml) then
             den1d2(k)=den1d(k)
             dpmin1d2(k)=dpmin1d(k)
             dp1d2(k)=dp1d(k)
       elseif (k==kml) then
             dpmin1d2(k)=dpmin1d(k+kk-kk2)
           do k2=k,k+kmn-kml
             den1d2(k)=den1d2(k)+den1d(k2)*dp1d(k2)
             dp1d2(k)=dp1d2(k)+dp1d(k2)
           enddo
             den1d2(k)=den1d2(k)/dp1d2(k)
       elseif (k>kml) then
             den1d2(k)=den1d(k+kk-kk2)
             dpmin1d2(k)=dpmin1d(k+kk-kk2)
             dp1d2(k)=dp1d(k+kk-kk2)
       endif
     enddo

!sanity check before entering the adjustment process

    if(kmn2.ge.kmx2.or.kmn2.ge.kk2.or.kmx2.eq.1) then
       error(i,j)=1
    else
       called(i,j)=1
       CALL ch(kk2,kmn2,kmx2,dz1d,dzout,den1d2,g,dpmin1d2,dp1d2,ddp1d2,err)


! reset vertical arrays including those in the consolidated layer

       fract=(dp1d2(kml)+ddp1d2(kml))/dp1d2(kml)
       do k=1,kk2
          if (k<kml) then
             ddp1d(k)=ddp1d2(k)
          elseif (k==kml) then
             do k2=k,k+kmn-kml
                ddp1d(k2)=(fract-1.0)*dp1d(k2)
             enddo
          elseif (k>kml) then
             ddp1d(k+kk-kk2)=ddp1d2(k)
          endif
       enddo

!apply correction to pressure field
       if(err.eq.0)then
          error(i,j)=0
          do k=1,kk
             !ddp(i,j,k)=ddp1d(k)
             if(dpin(i,j,k)+ddp1d(k).gt.0.0 .and. ddp1d(k).ne.0.0) then
                 dpout(i,j,k)=dpin(i,j,k)+ddp1d(k)
                 !print *, k,ddp1d(k)/9806.,dpin(i,j,k)/9806.,dpout(i,j,k)/9806.
             endif
          enddo
       endif ! err
       endif !called
!       endif !ip=1

    enddo ! i loop
  enddo   ! j loop

END SUBROUTINE

subroutine CH(n_lyr, kmn, kmx, dzin, dzout, den, g, dpmin, dp, ddp,err)
use mkinds

! DESCRIPTION:  Computes innovations for layer (baroclinic pressure)
!               thickness from innovations for surface height using
!               Cooper-Haines method for HYCOM layers.
!
!               Whenever possible, only two layers will have
!               non-zero innovations, one above the main thermocline
!               and one below.
!               Their innovations are equal in magnitude and opposite
!               in sign, so that the resulting pressure thickness for
!               the water column will not change the bottom pressure.
!               The magnitude of the innovations should guarantee that
!               the sum of the coresponding z-thickness innovations is
!               equal to the sea-surface height innovation.
!
!               If constraints on minimum allowed layer thickness
!               prevents a sufficient part of one layer's pressure
!               thickness to be transferred to the other to accomodate
!               the ssh innovation, then that layers innovation will be
!               as (negatively) large as allowed, and the procedure will
!               be repeated for the  adjacent layer.
! PARAMETERS:
!     Name         Type     Usage           Description
!   ---------    --------   -----    -------------------------------
!    den         real       input    density profile (consistent with hycom density) 
!                                           in kg/m^3
!    dp          real       input    prior layer thickness in pressure units
!                                          (in pascal=kg/(m*s2))
!    ddp         real       output   pressure innovations
!    dpmin       real       input    minimum allowed layer thickness in press units
!    dzin        real       input    ssh innovation in meters
!    dzout       real       output   output (applyable) ssh innovation
!    g           real       input    gravitational constant
!    kmn         integer    input    index of upper-most layer with non-zero
!                                    innovation
!    kmx         integer    input    index of lower-most layer with non-zero
!                                    innovation
!    n_lyr       integer    input    max number layers
!
!

implicit  none

integer(i4)   ::   n_lyr
real(r4)      ::   deltap
real(r4)      ::   den (n_lyr)
real(r4)      ::   ddp(n_lyr)
real(r4)      ::   dp (n_lyr)
real(r4)      ::   dpmin(n_lyr)
real(r4)      ::   dz
real(r4)      ::   g
real(r4)      ::   thref, onem,dzin,dzout,sum1,sum2,eps,mindp
integer(i4)   ::   k, k1, k2, thisk1, thisk2, kmn, kmx, err, m
logical(bl)   ::   constraint

! check that no layer is thinner than dpmin, and kmn < kmx
      if(kmn.ge.kmx)then
!      write(6,*)'kmn.ge.kmx',kmn,kmx
      return
      endif
      do k=1,n_lyr
      if(dp(k).lt.dpmin(k))then
!      write(6,*)'dp < dpmin not allowed'
      return
      endif
      enddo
! acceptable error in sum dp
      eps=1.0  !mks pressure units ~ 1.e-4 meters
! initialize error to zero
      err=0
! layer-thickness innovations will be added to the following array
      do k = 1, n_lyr
         ddp(k) = 0.
      enddo

! put in dz the remaining innovation
      dz=dzin
      dzout=0.

! start iterations
! indices of upper-most and lower-most layers
      k1=kmn
      k2=kmx
!      write(6,*)'input k1,k2', k1,k2
      m=0
      do
      m=m+1

! k1 or k2 will be changed for next pass through do loop
      thisk1=k1
      thisk2=k2

! compute p-thickness adjustment to thisk1 (negative of that for p2)
! that will give z-thicknesses that account for ssh innovation dz

      if(den(thisk2)-den(thisk1)==0.0) return

      deltap=dz*den(thisk1)*den(thisk2)*g/(den(thisk2)-den(thisk1))
!      write(6,*)'m,thisk1,thisk2,deltap',m,thisk1,thisk2,deltap

! check the minimum thickness constraints

      constraint=.false.

      if (deltap .lt. dpmin(thisk1)-dp(thisk1))then
!      write(6,*)'thisk1,dpmin,dp,dpmin-dp',dpmin(thisk1),dp(thisk1),
!     .           dpmin(thisk1)-dp(thisk1)
! upper-most layer cannot be made thin enough
       constraint=.true.
! make it as thin as possible
       deltap=dpmin(thisk1)-dp(thisk1)
!        write(6,*)'constrained deltap',deltap
! increment upper-most layer for next iteration
       k1=k1+1
!       if(k1.ge.kmx) exit !BUG 
        if(k1.ge.thisk2) exit
      endif
!       write(6,*)'new k1',k1

      if (-deltap .lt. dpmin(thisk2)-dp(thisk2)) then
!        write(6,*)'thisk2,dpmin-dp',dpmin(thisk2)-dp(thisk2)
! lower-most layer cannot be made thin enough
       constraint=.true.
! make it as thin as possible
       deltap = -(dpmin(thisk2) - dp(thisk2))
!        write(6,*)'constrained deltap',deltap

! decrement lower-most layer for next iteration
       k2=k2-1
!      if(k2.le.kmn)exit !BUG
       if(k2.le.thisk1) exit
      endif
!      write(6,*)'new k2',k2


!     write(6,*)'after constraining', deltap

! add to innovation vector
      ddp(thisk1)=ddp(thisk1)+deltap
      ddp(thisk2)=ddp(thisk2)-deltap
!      write(6,*)'deltap',deltap
!      write(6,*)'ddp after this correction'
!      write(6,*)thisk1,ddp(thisk1),ddp(thisk1)/(den(thisk1)*g)
!      write(6,*)thisk2,ddp(thisk2),ddp(thisk2)/(den(thisk2)*g)
! ssh correction. 
!      write(6,*) 'ssh correction',
!     . deltap/(den(thisk1)*g)-deltap/(den(thisk2)*g)

! if constraints were not encountered, stop
      if(constraint.eqv..false.) exit

! if constraints were encountered, add applyable innovation,
! replace ssh innovation with the part that has not be accounted for
      dzout=dzout+deltap*(den(thisk2)-den(thisk1))/(g*den(thisk1)*den(thisk2))
!     write(6,*)'dz',dz
      dz=dz-deltap*(den(thisk2)-den(thisk1))/(g*den(thisk1)*den(thisk2))
!      write(6,*)'remaining dz after present correction',dz

      enddo
! add applyable innovation at the end of the subroutine
      dzout=dzout+deltap*(den(thisk2)-den(thisk1))/(g*den(thisk1)*den(thisk2))
! remaining unaccounted dz at the end of the subroutine
      dz=dz-deltap*(den(thisk2)-den(thisk1))/(g*den(thisk1)*den(thisk2))
!     write(6,*)'remaining dz at end of subroutine',dz
      sum1=0
      sum2=0
      mindp=0.
      do k=kmn,kmx
      if(dp(k)+ddp(k)-dpmin(k).lt.-eps.and.ddp(k).ne.0.)then
!      write(6,*)'error,k,dp,ddp,dp+ddp,dpmin'
!      write(6,*)k,dp(k),ddp(k),dp(k)+ddp(k),dpmin(k)
      if(dp(k)+ddp(k).lt.0) write(6,*)'fatal error, negative output dp',dp(k)+ddp(k)

      err=1
      endif
      sum1=sum1+ddp(k)
      sum2=sum2+ddp(k)/(g*den(k))
      enddo
!     write (6,*) sum1, sum2 
!     do k=1,n_lyr
!     write(6,*)k,dp(k)/9806.,ddp(k)/9806.
!     enddo
      if(abs(sum1).gt.eps)then
      err=1
!      write(6,*)'correction sum ddp (should be 0) and sum heights (ssh)', sum1,sum2
!      write(6,*)'output: dpp, dpp/(g*den)'
!      do k=kmn,kmx
!      write(6,*) i,j,k,ddp(k),ddp(k)/(g*den(k))
!      enddo
!      stop
      endif

! now ddp should contain pressure-thickness innovations for all layers

return
end subroutine











end module      
