module mlprofiles
use mkinds
use mncio
use mgrid
use mz2hyb
use mglobals


          implicit none
   
          real(r4),parameter        :: sigdmin  = 0.005
          real(r4),parameter        :: sigdpmin = 0.5
          real(r4),parameter        :: factdp   = 0.02
          real(r4),parameter        :: fact_tserr=0.5
          real(r4)                  :: fact_tserr_tau
          real(r4),parameter        :: argo_temp_err=0.01, argo_sal_err=0.005

contains



subroutine zprofile2lyr(nlvls,nl,error_growth_factor,pz,tz,sz,ml,pl,tl,sl,rl,terr,serr,thkerr)

        implicit none

        integer(i4)               :: nlvls
        integer(i4)               :: nl
        real(r4)                  :: error_growth_factor
        
        real(r4)                  :: ml(nl)
        real(r4)                  :: pz(nlvls)
        real(r4)                  :: tz(nlvls)
        real(r4)                  :: sz(nlvls)
        real(r4)                  :: rz(nlvls)
        !real(r4)                  :: uz(nlvls)
        !real(r4)                  :: vz(nlvls)
        real(r4)                  :: tzerr(nlvls)
        real(r4)                  :: szerr(nlvls)

        
        real(r4)                  :: pl(nl)
        real(r4)                  :: rl(nl)
        real(r4)                  :: sl(nl)
        real(r4)                  :: tl(nl)
        real(r4)                  :: ul(nl)
        real(r4)                  :: vl(nl)
        real(r4)                  :: dp(nl)
        real(r4)                  :: terr(nl)
        real(r4)                  :: serr(nl)
        real(r4)                  :: derr(nl)
        real(r4)                  :: thkerr(nl)
        integer(i4)               :: k,kmx


                       do k=1,nlvls
                         rz(k)= sig(tz(k),sz(k),sigver)
                       enddo

                       fact_tserr_tau=fact_tserr*exp(-1.0*error_growth_factor)
                       tzerr=argo_temp_err*(1. + fact_tserr_tau)
                       szerr=argo_sal_err*(1.  + fact_tserr_tau)


             ! layerize the profile
            pl=0.0
            thkmin=3.0
            call layerize(nlvls,pz,tz,sz,rz,tzerr,szerr,pz(nlvls),&
           nl,pl,rl,sl,tl,terr,serr,thbase,thkmin,nhybrd,nsigma,dp00,dp00x,dp00f,ds00,ds00x,ds00f&
           ,dp0k,ds0k(1:nsigma),ilspec,ml,thkmin,sigver)
           pl(1)=0.0

           ! find the last layer with info
           kmx=nlvls
            do k=1,nl-1
            if(abs(tl(K+1)-tl(k))<kbot_tol .and. abs(sl(K+1)-sl(k))<kbot_tol .and. abs(pl(K+1)-pl(k))<kbot_tol )then
                kmx=k
            exit
            endif
           enddo

!           diag info


           do k=1,nl
           !write(*,'(I5,8F16.4)') k,pl(k),tl(k),terr(k),sl(k),serr(k),rl(k),derr(k),thkerr(k)

               if(k<kmx) then
                 derr(k)=min(abs(dsig(tl(k),sl(k),terr(k),serr(k),sigver)),max(abs(mlayer(k)-rl(k)),sigdmin))
                 derr(k)=max(sigdmin,derr(k))
                 thkerr(k)=max(sigdpmin, (factdp*pl(k) -(factdp*pl(k)-sigdpmin)*(derr(k)-sigdmin)/derr(k)))
                 thkerr(k)=min(100.0,thkerr(k))
               else
                 derr(k)=sigdmin
                 thkerr(k)=sigdpmin

                 !write(*,'(I5,8F16.4)') k,pl(k),tl(k),terr(k),sl(k),serr(k),rl(k),derr(k),thkerr(k)

                endif
             enddo

          end subroutine

          
          
          
          
          
          








end module       
