module mminfo
use mkinds
use mconstants
use mdates

! common variable used by all schemes

real(r4)                      :: stime(1)
character(len=20)             :: model
character(len=20)             :: forecastFile
character(len=20)             :: analysisFile
character(len=5)              :: pfx
character(len=10)             :: analysis_date
real(r4)                      :: time_offset
character(:),allocatable      :: FCFileName
character(:),allocatable      :: fcmodel
character(:),allocatable      :: XAFileName
character(:),allocatable      :: XIFileName

character(:),allocatable      :: XAPFileName
character(:),allocatable      :: XACFileName
character(:),allocatable      :: XFPFileName
character(:),allocatable      :: XFCFileName
character(:),allocatable      :: xfFile
character(:),allocatable      :: xaFile
character(:),allocatable      :: mpfx
real(r4),allocatable          :: analysis_levels(:)
integer(i4)                   :: nanalysis_levels
integer(i4)                   :: c2r
integer(i4)                   :: mr
integer(i4)                   :: lm

NAMELIST/model_info/model,forecastFile,analysisFile,pfx,time_offset,c2r,mr,lm

contains

subroutine set_analysis_date()
use mkinds
implicit none

character(len=10)         :: buffer
integer(i4)               :: iargc
integer(i4)               :: n
real(r4)                  :: toffset

! check command line arguments and get date

n=COMMAND_ARGUMENT_COUNT()
if (n >= 1) then
       call get_command_argument(1,buffer)
       read (buffer,*) analysis_date
else
       call date_and_time(analysis_date)
       analysis_date(9:10)="00"
endif
call cymd2hday(analysis_date,stime(1))
end subroutine set_analysis_date

subroutine set_model_info()
        implicit none
        character(4)                 :: cyear
        character(3)                 :: cday
        character(2)                 :: chour
        character(4)                 :: clevel
        integer(i4)                  :: stat
        integer(i4)                  :: year
        integer(i4)                  :: day
        integer(i4)                  :: hour

        ! read analysis parameters
        OPEN(21,FILE='tsis.nlist')
        READ(21,NML=model_info)
        CLOSE(21)
        
        stime(1)=stime(1)-time_offset
        call hday2ydnhh(stime(1),year,day,hour)
        write(cyear(1:4),'(i4.4)') year
        write(cday(1:3),'(i3.3)')  day
        Write(chour(1:2),'(i2.2)') hour
        
        
        FCmodel=trim(model)

        FCFileName=trim(forecastFile)      !"XF."//cyear//"_"//cday//"_"//chour//".nc"     !trim(fcstFile)
        XAFileName="inc."//cyear//"_"//cday//"_"//chour//".nc"     !trim(anlsFile)
        XIFileName="inc."//cyear//"_"//cday//"_"//chour//".nc" 
        XFCFileName="xfc."//cyear//"_"//cday//"_"//chour//".nc"     !trim(anlsFile)
        XAPFileName="xap."//cyear//"_"//cday//"_"//chour//".nc"

        XFFile=FCFileName
        XAFile=XAFileName

        nanalysis_levels=60
        allocate(analysis_levels(nanalysis_levels))
        analysis_levels=[0., 5., 10., 20., 30., 40., 50., 60., 70., 80., 90., 100., 125., 150., 175., 200.,& 
    225., 250., 275., 300., 325., 350., 375., 400., 425., 450., 475., 500., 600., 700., &
    800., 900., 1000., 1100., 1200., 1300., 1400., 1500., 1600., 1700., 1800., 1900., &
    2000., 2200., 2400., 2600., 2800., 3000., 3200., 3400., 3600., 3800., 4000., 4200.,& 
    4400., 4600., 4800., 5000., 5200., 5500.]

end subroutine


end module mminfo
