module mnavo
 use mkinds
 use mconstants
 use mdates
 use mncio
 use mobs
 use msearch


 real(r4),allocatable      :: l4sst_val(:,:)
 real(r4),allocatable      :: l4sst_err(:,:)
 real(r4),allocatable      :: l4ice_cov(:,:)
 integer(i4)               :: nob_grp
 integer(i4),allocatable   :: ob_grp_present(:)

contains

        subroutine navo_l4sst_2cobs(cdate,iflag)
implicit none


character(*)              :: cdate
integer(i4)               :: gnx
integer(i4)               :: gny
real(r4)                  :: scl_sst,off_sst,fill_value_sst
real(r4)                  :: scl_err,off_err,fill_value_err
real(r4)                  :: scl_ice,off_ice,fill_value_ice
real(r4)                  :: grdi,grdj,ptlon
integer(i4)               :: i,j,k
character(:),allocatable  :: inFile
logical(bl)               :: lexist
real(r4),allocatable      :: tmp_lon(:)
real(r4),allocatable      :: tmp_lat(:)
real(r4),allocatable      :: tmp_sst(:,:)
real(r4),allocatable      :: tmp_sst_err(:,:)
real(r4),allocatable      :: tmp_ice(:,:)
integer(i4)               :: iflag


inFile=trim(l4sst_data_location)//cdate(1:4)//"/"//trim(l4_sst_file_pfx)//"_"//cdate(1:8)//".nc"
INQUIRE(FILE=inFile, EXIST=lexist)
 if(lexist) then
   write(*,*) "....L4 SST FILE....", inFile

   call nciopn(inFile,fid)
         call ncioin(inFile,fid,"lon",gnx)
         call ncioin(inFile,fid,"lat",gny)
         allocate(tmp_lon(gnx))
         allocate(tmp_lat(gny))
         allocate(tmp_sst(gnx,gny))
         allocate(tmp_sst_err(gnx,gny))
         allocate(tmp_ice(gnx,gny))
         allocate(l4ice_cov(gnx,gny))
!         if(.not. allocated(l4obs_lon)) allocate(l4obs_lon(gnx))
!         if(.not. allocated(l4obs_lat)) allocate(l4obs_lat(gny))
         allocate(l4sst_val(gnx,gny))
         allocate(l4sst_err(gnx,gny))

         call nciorv(inFile,fid,"lon",tmp_lon)
         call nciorv(inFile,fid,"lat",tmp_lat)

         call nciorv(inFile,fid,"analysed_sst",tmp_sst)
         call nciorv(inFile,fid,"analysied_error",tmp_sst_err)
         call nciorv(inFile,fid,"sea_ice_fraction",tmp_ice)
         call nciora(inFile,fid,"analysed_sst","_FillValue",fill_value_sst)
         call nciora(inFile,fid,"analysed_sst","scale_factor",scl_sst)
         call nciora(inFile,fid,"analysed_sst","add_offset",off_sst)
         call nciora(inFile,fid,"analysed_error","scale_factor",scl_err)
         call nciora(inFile,fid,"analysed_error","_FillValue",fill_value_sst)
         call nciora(inFile,fid,"analysed_error","add_offset",off_err)
         call nciora(inFile,fid,"sea_ice_fraction","scale_factor",scl_ice)
         call nciora(inFile,fid,"sea_ice_fraction","_FillValue",fill_value_ice)
         call nciora(inFile,fid,"sea_ice_fraction","add_offset",off_ice)

         call nciocl(inFile,fid)

         where(tmp_sst>fill_value_sst)
                 tmp_sst=tmp_sst*scl_sst+off_sst
                 tmp_sst_err=tmp_sst_err*scl_err+off_err
         else where
                 tmp_sst=spval
                 tmp_sst_err=spval
         end where

         where(tmp_ice>fill_value_ice)
                 tmp_ice=tmp_ice*scl_ice+off_ice
         else where
                 tmp_ice=spval
         end where

         do j=1,gny
          do i=1,gnx
           if(l4obs_lon(i) <0.0 ) then 
                   ptlon=l4obs_lon(i)+360.0
           else
                  ptlon=l4obs_lon(i)
          endif 
           grdi=ridx(tmp_lon,ptlon)
           grdj=ridx(tmp_lat,l4obs_lat(j))

           if(grdi>-99.0 .and. grdj>-99.0) then
             l4sst_val(i,j)=tmp_sst(nint(grdi),nint(grdj))
             l4sst_err(i,j)=tmp_sst_err(nint(grdi),nint(grdj))
             l4ice_cov(i,j)=tmp_ice(nint(grdi),nint(grdj))
           endif
 
          enddo
         enddo
          
         iflag=0
         else
         iflag=-1
         Write(*,*)  "....L4 SST file not present....",inFile
 endif

end subroutine




end module
