module mobsio

use mkinds
use mncio
use mglobals
use mobs
use mminfo
use mdates


!==========================================================================================================
!                                             Subroutine List                                             !
!==========================================================================================================
!1. subroutine write_cobs_file_skel(filename)
!2. subroutine cobs_add_profiles(filename,ncount,nzl,prof_num,zlevels,plon,plat,ptime,
!                                 temp,saln,ctemp,csaln,ctstd,csstd,it,is,pvalid,ityp)
!===========================================================================================================



contains


subroutine write_tsis_obsfile(cdate,pfx,nprofiles,nlayers,ntyp,nx,ny)

IMPLICIT NONE
character(len=*)               :: cdate
character(len=3)               :: typ
character(len=5)               :: pfx
integer(i4)                    :: nprofiles
integer(i4)                    :: nlayers
character(:),allocatable       :: filename
integer(i4)                    :: i,j,iunit,ntyp
integer(i4)                    :: vdims(3),vdim(1),vdims2(2)
integer(i4),allocatable        :: ityp(:),iprofnum(:),ilayer(:),ob_grp_present(:),iob_grp(:)
integer(i4)                    :: nx,ny,nob_grp
real(r4)                       :: xc(nx),yc(ny)

do i=1,nx
xc(i)=i
enddo

do j=1,ny
yc(j)=j
enddo

allocate(ityp(ntyp))
allocate(iprofnum(nprofiles))
allocate(ilayer(nlayers))

obsgrp=0
if(nprofiles>1) obsgrp(l2_tsprofiles)=1

do i=1,ntyp
   ityp(i)=i
enddo

do i=1,nlayers
   ilayer(i)=i
enddo

do i=1,nprofiles
   iprofnum(i)=i
enddo

!do i=1,nob_grp
!   iob_grp(i)=i
!enddo



filename=trim(tsis_obs_location)//"tsis_obs_"//trim(pfx)//"_"//cdate//".nc"

!create file

call nciocf(filename,fid)
!create dimension and coordinate variable 1
vname="obs_typ"
vtype=NF90_int
vdim(1)=1
call nciodd(filename,fid,vname,ntyp)
call nciocv(filename,fid,vname,vtype,vdim)
call nciowa(filename,fid,vname,'long_name','observation_type')
call nciowa(filename,fid,vname,'standard_name','observation_type')

vname="obs_layer"
vtype=NF90_int
vdim(1)=2
call nciodd(filename,fid,vname,nlayers)
call nciocv(filename,fid,vname,vtype,vdim)
call nciowa(filename,fid,vname,'long_name','observation_layer')
call nciowa(filename,fid,vname,'standard_name','observation_layer')

vname="prof_num"
vtype=NF90_int
vdim(1)=3
call nciodd(filename,fid,vname,nprofiles)
call nciocv(filename,fid,vname,vtype,vdim)
call nciowa(filename,fid,vname,'long_name','profile_number')
call nciowa(filename,fid,vname,'standard_name','profile_number')

vname="xc"
vtype=NF90_FLOAT
vdim(1)=4
call nciodd(filename,fid,vname,nx)
call nciocv(filename,fid,vname,vtype,vdim)

vname="yc"
vtype=NF90_FLOAT
vdim(1)=5
call nciodd(filename,fid,vname,ny)
call nciocv(filename,fid,vname,vtype,vdim)

vname="nobsgrp"
vtype=NF90_INT
vdim(1)=6
call nciodd(filename,fid,vname,nobsgrp)
call nciocv(filename,fid,vname,vtype,vdim)
call nciowa(filename,fid,vname,'long_name','no_observation_groups')

!create data variable 1
vname="lon"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','longitude')
call nciowa(filename,fid,vname,'standard_name','longitude')
call nciowa(filename,fid,vname,'units','degrees_east')

!create data variable 4
vname="lat"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','latitude')
call nciowa(filename,fid,vname,'standard_name','latitude')
call nciowa(filename,fid,vname,'units','degrees_north')

!create data variable 4
vname="time"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)

!create data variable 4
vname="qc"
vtype=NF90_int
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)

!create data variable 6
vname="val"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','observation value')
call nciowa(filename,fid,vname,'standard_name','observation value')

!create data variable 7
vname="err"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','observation err')
call nciowa(filename,fid,vname,'standard_name','observation error')

!create data variable 10
vname="grdi"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','model grid index')
call nciowa(filename,fid,vname,'standard_name','x-grid-index')

!create data variable 10
vname="grdj"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','y-model grid index')
call nciowa(filename,fid,vname,'standard_name','y-grid-index')

!create data variable 10
vname="inov"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)

!create data variable 10
vname="bkg"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)

!create data variable 10
vname="residual"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)

!create data variable 10
vname="id"
vtype=NF90_INT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','obs_flag')
call nciowa(filename,fid,vname,'standard_name','obs_flag')

!create data variable 10
vname="obsgrp"
vtype=NF90_INT
vdim=(/6/)
call nciocv(filename,fid,vname,vtype,vdim)
call nciowa(filename,fid,vname,'standard_name','obs_groups_present')

!data variable 10
vname="l3ssh"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','sea_surface_height')
call nciowa(filename,fid,vname,'standard_name','sea_surface_height')
call nciowa(filename,fid,vname,'units','m')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l3ssh_err"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','sea_surface_height_err')
call nciowa(filename,fid,vname,'standard_name','sea_surface_height_err')
call nciowa(filename,fid,vname,'units','m')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l4ssh"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','gridded_sea_surface_height')
call nciowa(filename,fid,vname,'standard_name','gridded_sea_surface_height')
call nciowa(filename,fid,vname,'units','m')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l4ssh_err"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','gridded_sea_surface_height_err')
call nciowa(filename,fid,vname,'standard_name','gridded_sea_surface_height_err')
call nciowa(filename,fid,vname,'units','m')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l3sst"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','sea_surface_temperature')
call nciowa(filename,fid,vname,'standard_name','sea_surface_temperature')
call nciowa(filename,fid,vname,'units','degc')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l3sst_err"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','sea_surface_temperature_err')
call nciowa(filename,fid,vname,'standard_name','sea_surface_temperature_err')
call nciowa(filename,fid,vname,'units','degc')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l2sst"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','sea_surface_temperature')
call nciowa(filename,fid,vname,'standard_name','sea_surface_temperature')
call nciowa(filename,fid,vname,'units','degc')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l2sst_err"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','sea_surface_temperature_err')
call nciowa(filename,fid,vname,'standard_name','sea_surface_temperature_err')
call nciowa(filename,fid,vname,'units','degc')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l4sst"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','sea_surface_temperature')
call nciowa(filename,fid,vname,'standard_name','sea_surface_temperature')
call nciowa(filename,fid,vname,'units','degc')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

vname="l4sst_err"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','sea_surface_temperature_err')
call nciowa(filename,fid,vname,'standard_name','sea_surface_temperature_err')
call nciowa(filename,fid,vname,'units','degc')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l2sss"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','l2_sea_surface_salinity')
call nciowa(filename,fid,vname,'standard_name','l2_sea_surface_salinity')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

vname="l2sss_err"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','l2_sea_surface_salinity_err')
call nciowa(filename,fid,vname,'standard_name','l2_sea_surface_salinity_err')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 11
vname="uos"
vtype=NF90_float
vdim2d=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdim2d)
call nciowa(filename,fid,vname,'long_name','eastward_seawater_velocity_surface')
call nciowa(filename,fid,vname,'standard_name','zonal velocity')
call nciowa(filename,fid,vname,'units','ms-1')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 12
vname="vos"
vtype=NF90_float
vdim2d=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdim2d)
call nciowa(filename,fid,vname,'long_name','northward_seawater_velocity_surface')
call nciowa(filename,fid,vname,'standard_name','meridional velocity')
call nciowa(filename,fid,vname,'units','ms-1')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

call ncioed(filename,fid)

! write data into variables
call nciowv(filename,fid,"prof_num",iprofnum)
call nciowv(filename,fid,"obs_typ",ityp)
call nciowv(filename,fid,"obs_layer",ilayer)
!call nciowv(filename,fid,"ob_grp",iob_grp)
call nciowv(filename,fid,"xc",xc)
call nciowv(filename,fid,"yc",yc)
call nciowv(filename,fid,"lon",profile_lyr_obs%lon)
call nciowv(filename,fid,"lat",profile_lyr_obs%lat)
call nciowv(filename,fid,"time",profile_lyr_obs%time)
call nciowv(filename,fid,"qc",profile_lyr_obs%qc)
call nciowv(filename,fid,"val",profile_lyr_obs%val)
call nciowv(filename,fid,"err",profile_lyr_obs%err)
call nciowv(filename,fid,"grdi",profile_lyr_obs%grdi)
call nciowv(filename,fid,"grdj",profile_lyr_obs%grdj)
call nciowv(filename,fid,"id",profile_lyr_obs%id)
call nciowv(filename,fid,"obsgrp",obsgrp)
call nciowv(filename,fid,"bkg",profile_lyr_obs%bkg)
call nciowv(filename,fid,"inov",profile_lyr_obs%inov)
call nciowv(filename,fid,"residual",profile_lyr_obs%res)

! close file

call nciocl(filename,fid)

end subroutine write_tsis_obsfile

subroutine write_tsis_inovFile(cdate,pfx,clon,clat,nprofiles,nlevels,ntyp,nx,ny)


IMPLICIT NONE
character(len=*)               :: cdate
character(len=3)               :: typ
character(len=5)               :: pfx
integer(i4)                    :: nprofiles
integer(i4)                    :: nlevels
character(:),allocatable       :: filename
integer(i4)                    :: i,j,iunit,ntyp
integer(i4)                    :: vdims(3),vdim(1),vdims2(2)
integer(i4),allocatable        :: ityp(:),iprofnum(:),ilayer(:),ob_grp_present(:),iob_grp(:)
integer(i4)                    :: nx,ny,nt,nob_grp
real(r4)                       :: xc(nx),yc(ny),clon(nx),clat(ny)
real(r4)                       :: ctime(1)

call cymd2hday(cdate,ctime(1))
nt=1
do i=1,nx
xc(i)=i
enddo

do j=1,ny
yc(j)=j
enddo

allocate(ityp(ntyp))
allocate(iprofnum(nprofiles))

do i=1,ntyp
   ityp(i)=i
enddo

do i=1,nprofiles
   iprofnum(i)=i
enddo


filename=trim(tsis_obs_location)//"tsis_inov_"//trim(pfx)//"_"//cdate//".nc"



!create file

call nciocf(filename,fid)
!create dimension and coordinate variable 1
vname="obs_typ"
vtype=NF90_int
vdim(1)=1
call nciodd(filename,fid,vname,ntyp)
call nciocv(filename,fid,vname,vtype,vdim)
call nciowa(filename,fid,vname,'long_name','observation_type')
call nciowa(filename,fid,vname,'standard_name','observation_type')

vname="obs_level"
vtype=NF90_int
vdim(1)=2
call nciodd(filename,fid,vname,nlevels)
call nciocv(filename,fid,vname,vtype,vdim)
call nciowa(filename,fid,vname,'long_name','observation_layer')
call nciowa(filename,fid,vname,'standard_name','observation_layer')

vname="prof_num"
vtype=NF90_int
vdim(1)=3
call nciodd(filename,fid,vname,nprofiles)
call nciocv(filename,fid,vname,vtype,vdim)
call nciowa(filename,fid,vname,'long_name','profile_number')
call nciowa(filename,fid,vname,'standard_name','profile_number')

vname="clon"
vtype=NF90_FLOAT
vdim(1)=4
call nciodd(filename,fid,vname,nx)
call nciocv(filename,fid,vname,vtype,vdim)

vname="clat"
vtype=NF90_FLOAT
vdim(1)=5
call nciodd(filename,fid,vname,ny)
call nciocv(filename,fid,vname,vtype,vdim)

vname="ctime"
vtype=NF90_FLOAT
vdim(1)=6
call nciodd(filename,fid,vname,nt)
call nciocv(filename,fid,vname,vtype,vdim)

!create data variable 1
vname="lon"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','longitude')
call nciowa(filename,fid,vname,'units','degrees_east')

!create data variable 4
vname="lat"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','latitude')
call nciowa(filename,fid,vname,'units','degrees_north')

!create data variable 4
vname="time"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)

!create data variable 6
vname="val"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','profile_obs_value')
call nciowa(filename,fid,vname,'standard_name','profile_obs_value')
call nciowa(filename,fid,vname,'_FillValue',-99.0)

!create data variable 6
vname="inov"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','innovation value')
call nciowa(filename,fid,vname,'standard_name','innovation value')
call nciowa(filename,fid,vname,'_FillValue',-99.0)

!create data variable 10
vname="residual"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','residual value')
call nciowa(filename,fid,vname,'standard_name','residual value')
call nciowa(filename,fid,vname,'_FillValue',-99.0)


!create data variable 10
vname="valid"
vtype=NF90_int
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)

!create data variable 10
vname="grdi"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','model grid index')
call nciowa(filename,fid,vname,'standard_name','x-grid-index')

!create data variable 10
vname="grdj"
vtype=NF90_FLOAT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','y-model grid index')
call nciowa(filename,fid,vname,'standard_name','y-grid-index')

!create data variable 10
vname="id"
vtype=NF90_INT
vdims=(/1,2,3/)
call nciocv(filename,fid,vname,vtype,vdims)
call nciowa(filename,fid,vname,'long_name','obs_flag')
call nciowa(filename,fid,vname,'standard_name','obs_flag')


!data variable 10
vname="l3ssh_inov"
vtype=NF90_float
vdim3d=(/4,5,6/)
call nciocv(filename,fid,vname,vtype,vdim3d)
call nciowa(filename,fid,vname,'long_name','sea_surface_height_innovation')
call nciowa(filename,fid,vname,'units','m')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)


!data variable 10
vname="l3ssh_resid"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','sea_surface_height_residual')
call nciowa(filename,fid,vname,'units','m')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l4ssh_inov"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','gridded_sea_surface_height_innovation')
call nciowa(filename,fid,vname,'units','m')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l4ssh_resid"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','gridded_sea_surface_height_residual')
call nciowa(filename,fid,vname,'units','m')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l3sst_inov"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','l3_sea_surface_temperature_innovation')
call nciowa(filename,fid,vname,'units','degc')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l3sst_resid"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','l3_sea_surface_temperature_residual')
call nciowa(filename,fid,vname,'units','degc')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l2sst_inov"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','l2_sea_surface_temperature_innovation')
call nciowa(filename,fid,vname,'units','degc')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 10
vname="l2sst_resid"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','l2_sea_surface_temperature_resid')
call nciowa(filename,fid,vname,'units','degc')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

vname="l4sst_inov"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','l4_sea_surface_temperature_innovation')
call nciowa(filename,fid,vname,'units','degc')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

vname="l4sst_resid"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','l4_sea_surface_temperature_resid')
call nciowa(filename,fid,vname,'units','degc')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

vname="l2sss_inov"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','l2_sea_surface_salinity_innovation')
call nciowa(filename,fid,vname,'units','')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

vname="l2sss_resid"
vtype=NF90_float
vdims2=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdims2)
call nciowa(filename,fid,vname,'long_name','l2_sea_surface_salinity_resid')
call nciowa(filename,fid,vname,'units','')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 11
vname="uos_inov"
vtype=NF90_float
vdim2d=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdim2d)
call nciowa(filename,fid,vname,'long_name','eastward_seawater_velocity_surface_innovation')
call nciowa(filename,fid,vname,'units','ms-1')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

!data variable 12
vname="vos_inov"
vtype=NF90_float
vdim2d=(/4,5/)
call nciocv(filename,fid,vname,vtype,vdim2d)
call nciowa(filename,fid,vname,'long_name','northward_seawater_velocity_surface_innovation')
call nciowa(filename,fid,vname,'units','ms-1')
call nciowa(filename,fid,vname,'_FillValue',2.00**100)

call ncioed(filename,fid)



! write data into variables
call nciowv(filename,fid,"prof_num",iprofnum)
call nciowv(filename,fid,"obs_typ",ityp)
call nciowv(filename,fid,"obs_level",analysis_levels)
call nciowv(filename,fid,"clon",clon)
call nciowv(filename,fid,"clat",clat)
call nciowv(filename,fid,"ctime",ctime)
call nciowv(filename,fid,"lon",zinov%lon)
call nciowv(filename,fid,"lat",zinov%lat)
call nciowv(filename,fid,"time",zinov%time)
call nciowv(filename,fid,"grdi",zinov%grdi)
call nciowv(filename,fid,"grdj",zinov%grdj)
call nciowv(filename,fid,"valid",zinov%valid)
call nciowv(filename,fid,"inov",zinov%inov)
call nciowv(filename,fid,"val",zinov%val)

! close file

call nciocl(filename,fid)

end subroutine write_tsis_inovFile






end module
