module mpost


use mkinds
use mconstants
use mstate
use mobs
use mgrid
use mncio
use mlinint
use msearch
use mdates
use mlprofiles
use mminfo
use mglobals


   contains




   subroutine post()

   implicit none
   character(:),allocatable :: obsFile
   character(:),allocatable :: inovFile
   real(r4)                 :: res(nx,ny)
   real(r4)                 :: obs(nx,ny)
   real(r4)                 :: inov(nx,ny)
   real(r4),allocatable     :: vd(:,:,:),vm(:,:,:),gi(:,:,:),gj(:,:,:),pinov(:,:,:)
   integer(i4)              :: fid1,fid2
   integer(i4)              :: nprof,nz
   real(r4)                 :: dp(nl),tl(nl),sl(nl),cdpth(nl),pl(nl+1)
   integer(i4)              :: i,j,k,kmx
   real(r4)                 :: xi,yj
   integer(i4),allocatable              :: valid(:,:,:)
   integer(i4)              :: nbad


   obsFile=trim(tsis_obs_location)//"tsis_obs_"//pfx//"_"//analysis_date//".nc"
   inovFile=trim(tsis_obs_location)//"tsis_inov_"//pfx//"_"//analysis_date//".nc"

   nbad=0
   nz=nanalysis_levels

   CALL getssh(nx,ny,nl,kapref,pref,thbase,thref,msk3d(:,:,1),f3(:,:,:,2),f3(:,:,:,1),athk,fden-thbase,fpba,fpsikk,fthkk,fmgp,assh)

   call nciopn(obsFile,fid1)
   call nciopn(inovFile,fid2,'w')

  if(l2profile) then
   call ncioin(inovFile,fid2,"prof_num",nprof)
   allocate(vd(2,nz,nprof))
   allocate(vm(2,nz,nprof))
   allocate(gi(2,nz,nprof))
   allocate(gj(2,nz,nprof))
   allocate(valid(2,nz,nprof))
   vm=rsfill
  endif

   if(l3sla) then
   call nciorv(obsFile,fid1,"l3ssh",obs)
   call nciorv(inovFile,fid2,"l3ssh_inov",inov)
   res=spval
   where(obs /=spval)
         res=obs-assh
   end where
   call nciowv(inovFile,fid2,"l3ssh_resid",res)
   
   write(*,'(a,2F10.2)'), " ....l3ssh innovations: ", minval(inov,mask=inov<spval),maxval(inov,mask=inov<spval)
   write(*,'(a,2F10.2)'), " ....l3ssh residuals:   ", minval(res,mask=res<spval),maxval(res,mask=res<spval)
   endif


   if(l4sla) then
   call nciorv(obsFile,fid1,"l4ssh",obs)
   call nciorv(inovFile,fid2,"l4ssh_inov",inov)


   res=spval
   where(obs /=spval)
         res=obs-assh
   end where
   call nciowv(inovFile,fid2,"l4ssh_resid",res)
   write(*,'(a,2F10.2)'), " ....l4ssh innovations: ", minval(inov,mask=abs(inov)<spval),maxval(inov,mask=abs(inov)<spval)
   write(*,'(a,2F10.2)'), " ....l4ssh residuals:   ", minval(res,mask=abs(res)<spval),maxval(res,mask=abs(res)<spval)

   endif

   if(l3sst) then

   call nciorv(obsFile,fid1,"l3sst",obs)
   call nciorv(inovFile,fid2,"l3sst_inov",inov)
   res=spval
   where(obs /=spval)
         res=obs-asst
   end where
   call nciowv(inovFile,fid2,"l3sst_resid",res)
   write(*,'(a,2F10.2)'), " ....l3sst innovations: ", minval(inov,mask=inov<spval),maxval(inov,mask=inov<spval)
   write(*,'(a,2F10.2)'), " ....l3sst residuals:   ", minval(res,mask=res<spval),maxval(res,mask=res<spval)
  
   endif

!   call nciorv(obsFile,fid1,"l2sst",obs)
!   call nciorv(inovFile,fid2,"l2sst_inov",inov)
!   res=spval
!   where(obs /=spval)
!         res=obs-asst
!   end where
!   call nciowv(inovFile,fid2,"l2sst_resid",res)
!   write(*,'(a,2F10.2)'), " ....l2sst innovations: ", minval(inov,mask=inov<spval),maxval(inov,mask=inov<spval)
!   write(*,'(a,2F10.2)'), " ....l2sst residuals:   ",minval(res,mask=res<spval),maxval(res,mask=res<spval)


   if(l4sst) then
   call nciorv(obsFile,fid1,"l4sst",obs)
   call nciorv(inovFile,fid2,"l4sst_inov",inov)
   res=spval
   where(obs /=spval)
         res=obs-asst
   end where
   call nciowv(inovFile,fid2,"l4sst_resid",res)
   write(*,'(a,2F10.2)'), " ....l4sst innovations: ", minval(inov,mask=inov<spval),maxval(inov,mask=inov<spval)
   write(*,'(a,2F10.2)'), " ....l4sst residuals:   ",minval(res,mask=res<spval),maxval(res,mask=res<spval)

   endif

   ! do profile residuals

   if(l2profile) then
   call nciorv(inovFile,fid2,"val",vd)
   call nciorv(inovFile,fid2,"grdi",gi)
   call nciorv(inovFile,fid2,"grdj",gj)
   call nciorv(inovFile,fid2,"valid",valid)

   do i=1,nprof
  
   xi=gi(1,1,i)
   yj=gj(1,1,i)

   if(mdepth(int(xi),int(yj)) <spval) then


   dp(:)=athk(int(xi),int(yj),:)
   tl(:)=f3(int(xi),int(yj),:,1)
   sl(:)=f3(int(xi),int(yj),:,2)

         pl(1)=0.0
         do k=1,nl
          pl(k+1)=pl(k)+dp(k)*qonem
         enddo

         cdpth(1)=0.0
         cdpth(nl)=pl(nl+1)
         do k=2,nl-1
           cdpth(k)=0.5*(pl(k+1)+pl(k))
         enddo

         do k=2,nl
         if(tl(k)>=spval) then
                  tl(k)=tl(k-1)
                  sl(k)=sl(k-1)
          endif
!          print *, cdpth(k),tl(k),sl(k)
          enddo


         kmx=nz
         do k=1,nz
         if(analysis_levels(k)>cdpth(nl)) then
          kmx=k-1
          exit
         endif
         enddo


         vm(:,:,i)=rsfill

         call linint(nl,cdpth,tl,kmx,analysis_levels(1:kmx),vm(1,1:kmx,i))
         call linint(nl,cdpth,sl,kmx,analysis_levels(1:kmx),vm(2,1:kmx,i))

         vm(1,1,i)=tl(1)
         vm(2,1,i)=sl(1)

         do k=1,nz
         !if(valid(1,k,i)==1) then
          if(k<kmx .and. valid(1,k,i)==1) then
          vm(1,k,i)=(vd(1,k,i)-vm(1,k,i))*valid(1,k,i)
          !Write(*,'(2I5,2F10.2)'), i,k,vm(1,k,i),vm(2,k,i)
         else
           vm(1,k,i)=rsfill
          endif
        !  endif

        !  if(valid(2,k,i)==1) then
          if(k<kmx .and.  valid(2,k,i)==1) then
          vm(2,k,i)=(vd(2,k,i)-vm(2,k,i))*valid(2,k,i)
          !Write(*,'(2I5,2F10.2)'), i,k,vm(1,k,i),vm(2,k,i)
         else
           vm(2,k,i)=rsfill
          endif
        !  endif

         enddo

    else !
            nbad=nbad+1
            vm(:,:,i)=rsfill
    endif ! land sea mismatch
     enddo
   write(*,'(a,I5.5)') " ....land/sea mismatchs: ",nbad


   call nciowv(inovFile,fid2,"residual",vm)
   call nciocl(obsFile,fid1)
   call nciocl(inovFile,fid2)

  endif



   end subroutine post







end module mpost      
