module mpsla

use mkinds
use mconstants
use mobs
use mgrid
use mlinint
use msplint
use msearch
use mdates
use mstate
use msstat
use mminfo
use mobsio
use mfld


contains 

! prep_l3sla


subroutine prep_l3sla()


implicit none

!character(*)              :: analysis_date
!character(*)              :: pfx
character(10)             :: wanted_date
integer(i4)               :: ntwin
integer(i4)               :: ncount
integer(i4)               :: ix
integer(i4)               :: jy
real(r4)                  :: wsday,wday
logical(bl)               :: lobs
integer(i4)               :: i,j,k,ii,jj
real(r4)                  :: il,jl
character(:),allocatable  :: inFile
character(:),allocatable  :: outFile
character(:),allocatable  :: cobsFile
logical(bl)               :: lexist
real(r4),allocatable      :: l3sla_grid_val(:,:)
real(r4),allocatable      :: l3sla_grid_err(:,:)
real(r4),allocatable      :: l3sla_grid_inov(:,:)
real(r4),allocatable      :: mdt(:,:)
integer(i4),allocatable   :: bin(:,:),idx(:,:)
integer(i4)               :: nob_grp
integer(i4),allocatable   :: ob_grp_present(:)
real(r4),allocatable      :: slon(:)
real(r4),allocatable      :: slat(:)
real(r4),allocatable      :: sla(:)
character(:),allocatable  :: l4_sla_file_pfx
integer(i4)               :: scount
real(r4),parameter        :: sla_err=0.05
integer(i4)               :: stat


call cymd2hday(analysis_date,wday)


allocate(l3sla_grid_val(nx,ny))
allocate(l3sla_grid_err(nx,ny))
allocate(l3sla_grid_inov(nx,ny))
allocate(mdt(nx,ny))
allocate(idx(nx,ny))
allocate(bin(nx,ny))

l3sla_grid_val=0.0
l3sla_grid_inov=0.0
idx=0.0
bin=0.0
ncount=0
scount=0


INQUIRE(FILE=tsis_stat_file, EXIST=lexist)
if(lexist .eqv. .false.) then
        write(*,*) ("....missing mdt/stats file....")
        stop
endif


call nciopn(tsis_stat_file,fid)
call nciorv(tsis_stat_file,fid,"mdt",mdt)
call nciocl(tsis_stat_file,fid)

!1st pass to get the no of profiles
do k=sla_twin_start,sla_twin_end
  wsday=wday+real(k,r4)
  call hday2cymd(wsday,wanted_date)
  cobsFile=trim(cobs_location)//"/"//analysis_date(1:4)//"/tsis_cobs_"//wanted_date//".nc"
  INQUIRE(FILE=cobsFile, EXIST=lexist)
  if(lexist) then
    call nciopn(cobsFile,fid)
    call ncioiv(cobsFile,fid,"l3sla",stat)
   if(stat==0) then
    call ncioin(cobsFile,fid,"l3sla",scount)
     allocate(slon(scount))
     allocate(slat(scount))
     allocate(sla(scount))
    call nciorv(cobsFile,fid,"l3sla_lon",slon)
    call nciorv(cobsFile,fid,"l3sla_lat",slat)
    call nciorv(cobsFile,fid,"l3sla_val",sla)
      do i=1,scount
        ncount=ncount+1
        if(slon(i)>=lnmn .and. slon(i)<lnmx .and. slat(i)>=ltmn .and. slat(i)<ltmx) then

                ii=ridx(mlon(:,1),slon(i))
                jj=ridx(mlat(1,:),slat(i))

      if(ii/=-99.0 .and. jj/=-99.0) then
              if(mdepth(ii,jj)<spval) then
!!Alex       l3sla_grid_val(ii,jj)= l3sla_grid_val(ii,jj)+(sla(i)+mdt(ii,jj))
       l3sla_grid_val(ii,jj)= l3sla_grid_val(ii,jj)+(sla(i))

       l3sla_grid_err(ii,jj)=sla_err
       bin(ii,jj)=bin(ii,jj)+1
       endif
       endif


     endif
      enddo


      deallocate(slon,slat,sla)
      endif
      call nciocl(cobsFile,fid)
      endif ! file exist

enddo

where(bin>=1)
        l3sla_grid_val=l3sla_grid_val/bin
        l3sla_grid_inov=l3sla_grid_val-fssh
        idx=1
else where
        l3sla_grid_val=spval
        l3sla_grid_inov=spval
end where

!print *, minval(l3sla_grid_val,mask=l3sla_grid_val<spval), maxval(l3sla_grid_val,mask=l3sla_grid_val<spval)
!print *, minval(l3sla_grid_inov,mask=l3sla_grid_inov<spval), maxval(l3sla_grid_inov,mask=l3sla_grid_inov<spval)


if(ncount>0) then
           write(*,*) "....Total no of SLA observations points: ",ncount
           write(*,*) "....No of SLA observations for bin averages: ",sum(bin)
           write(*,*) "....Final no of binned SLA observations points: ",sum(idx)
           
           
           l3sla=.true.

            outFile=trim(tsis_obs_location)//"tsis_obs_"//trim(pfx)//"_"//analysis_date//".nc"
            call nciopn(outFile,fid,'w')
            call nciowv(outFile,fid,"l3ssh",l3sla_grid_val)
            call nciowv(outFile,fid,"l3ssh_err",l3sla_grid_err)
            call nciorv(outFile,fid,"obsgrp",obsgrp)
            obsgrp(l3_sla)=1
            call nciowv(outFile,fid,"obsgrp",obsgrp)
            call nciocl(outFile,fid)

            outFile=trim(tsis_obs_location)//"tsis_inov_"//trim(pfx)//"_"//analysis_date//".nc"
            call nciopn(outFile,fid,'w')
            call nciowv(outFile,fid,"l3ssh_inov",l3sla_grid_inov)
            call nciocl(outFile,fid)
 else

         write(*,*) "....no SLA observations ...."


 endif
end subroutine

subroutine prep_l4sla()

implicit none

character(10)             :: wanted_date
character(:),allocatable  :: inFile
logical(bl)               :: lexist
integer(i4)               :: gnx
integer(i4)               :: gny
integer(i4)               :: snx
integer(i4)               :: sny
integer(i4)               :: is,js,ie,je
integer(i4)               :: rs,re,ss,se
integer(i4)               :: ix,jy
real(r4),allocatable      :: glon(:)
real(r4),allocatable      :: glat(:)
real(r4),allocatable      :: slon(:),slat(:),ssla(:,:),serr(:,:)
real(r4),allocatable      :: mdt(:,:)
real(r4),allocatable      :: l4sla_val(:,:)
real(r4),allocatable      :: l4sla_err(:,:)
real(r4),allocatable      :: l4sla_inov(:,:)

real(r4)                  :: scl_sla,fill_value_sla
real(r4)                  :: scl_err,fill_value_err
real(r4)                  :: ptlat,ptlon
integer(i4)               :: i,j,k
integer(i4)               :: istat
logical(bl)               :: isPresent
integer(i4)               :: stat


scl_sla=1.0
scl_err=1.0
allocate(l4sla_val(nx,ny))
allocate(l4sla_err(nx,ny))
allocate(l4sla_inov(nx,ny))
allocate(mdt(nx,ny))


cobsFile=trim(cobs_location)//analysis_date(1:4)//"/tsis_cobs_"//analysis_date//".nc"

inquire (file=cobsFile,exist=lexist)

 if(lexist) then

         call nciopn(cobsFile,fid)
         call ncioiv(cobsFile,fid,"l4sla_val",stat)
   if(stat==0) then
         call ncioin(cobsFile,fid,"l4obs_lon",gnx)
         call ncioin(cobsFile,fid,"l4obs_lat",gny)

         allocate(glon(gnx))
         allocate(glat(gny))

         call nciorv(cobsFile,fid,"l4obs_lon",glon)
         call nciorv(cobsFile,fid,"l4obs_lat",glat)
!!Alex
         !write(*,*) "....glon  min/max ",gnx, minval(glon), maxval(glon)
         !write(*,*) "....glat  min/max ",gny, minval(glat), maxval(glat)
!!Alex

         glat(1)=-90.0
         glat(gny)=90.0
         glon(1)=-180.0
         glon(gnx)=180.0



         rs=ridx(glon,lnmn)
         re=ridx(glon,lnmx)
         ss=ridx(glat,ltmn)
         se=ridx(glat,ltmx)
         snx=(re-rs)+1
         sny=(se-ss)+1
         is=int(rs)
         js=int(ss)
!!Alex
         write(*,*) "....rs,re,ss,se ",rs,re,ss,se
         write(*,*) "....snx,sny,is,js ",snx,sny,is,js
!!Alex


         allocate(slon(snx))
         allocate(slat(sny))
         allocate(ssla(snx,sny))
         allocate(serr(snx,sny))

         slon=glon(rs:re)
         slat=glat(ss:se)


         call nciorv(cobsFile,fid,"l4sla_val",ssla,[is,js],[snx,sny])
         call nciora(cobsFile,fid,"l4sla_val","_FillValue",fill_value_sla)
         call nciorv(cobsFile,fid,"l4sla_err",serr,[is,js],[snx,sny])
         call nciora(cobsFile,fid,"l4sla_err","_FillValue",fill_value_err)
!!Alex
         write(*,*) "....sla_fill_value ",fill_value_sla

         call nciocl(cobsFile,fid)



         ! add mdt file

         call nciopn(tsis_stat_file,fid)
         call nciorv(tsis_stat_file,fid,"mdt",mdt)
         call nciocl(tsis_stat_file,fid)

         where(ssla<fill_value_sla)
                 ssla=ssla*scl_sla
         else where
                 ssla=0.0
         end where
!!Alex
         write(*,*) "....ssla  min/max ",minval(ssla), maxval(ssla)
!!Alex

         where(serr<fill_value_err)
                 serr=serr*scl_err
         else where
                 serr=0.04
         end where
!!Alex
         write(*,*) "....serr  min/max ",minval(serr), maxval(serr)
!!Alex


         ! extend sla


         call hextend(ssla,snx,sny,50,spval)
         call hextend(serr,snx,sny,50,spval)
         call intp_fld (snx,sny,nx,ny,slon,slat,mlon,mlat,ssla,l4sla_val)
         call intp_fld (snx,sny,nx,ny,slon,slat,mlon,mlat,serr,l4sla_err)
         where(abs(mdt)>3.0) mdt=0.0
                 
          l4sla_val=l4sla_val+mdt
          l4sla_inov=l4sla_val-fssh

        where(mdepth>=spval)
                 l4sla_val=spval
                 l4sla_err=spval
                 l4sla_inov=spval
         end where


         write(*,*) "....l4 sla obs  min/max ",minval(l4sla_val,mask=l4sla_val<spval), maxval(l4sla_val,mask=l4sla_val<spval)
         write(*,*) "....l4 sla inov min/max ",minval(l4sla_inov,mask=l4sla_inov<spval), maxval(l4sla_inov,mask=l4sla_inov<spval)


         inFile=trim(tsis_obs_location)//"tsis_obs_"//trim(pfx)//"_"//analysis_date//".nc"
         call nciopn(inFile,fid,'w')
         call nciowv(inFile,fid,"l4ssh",l4sla_val)
         call nciowv(inFile,fid,"l4ssh_err",l4sla_err)
         call nciorv(inFile,fid,"obsgrp",obsgrp)
         obsgrp(l4_sla)=1
         call nciowv(inFile,fid,"obsgrp",obsgrp)
         call nciocl(inFile,fid)

         inFile=trim(tsis_obs_location)//"tsis_inov_"//trim(pfx)//"_"//analysis_date//".nc"
         call nciopn(inFile,fid,'w')
         call nciowv(inFile,fid,"l4ssh_inov",l4sla_inov)
         call nciocl(inFile,fid)

         else
                 call nciocl(cobsFile,fid)
         endif ! l4sla exists


 else

   write(*,*) "....no l4sla obs....."
  !write(*,*) ".... l4sla:"//trim(cobsFile)//" is not present...."

 end if

end subroutine

















end module mpsla      
