module mpsss

use mkinds
use mconstants
use mobs
use mgrid
use mlinint
use msplint
use msearch
use mdates
use mstate
use msstat
use mminfo
use mobsio
use mfld


contains 

! prep_l2sss

subroutine prep_l2sss()

implicit none

character(10)             :: wanted_date
character(:),allocatable  :: inFile
logical(bl)               :: lexist
integer(i4)               :: gnx
integer(i4)               :: gny
integer(i4)               :: snx
integer(i4)               :: sny
integer(i4)               :: is,js,ie,je
integer(i4)               :: rs,re,ss,se
integer(i4)               :: ix,jy
real(r4),allocatable      :: glon(:)
real(r4),allocatable      :: glat(:)
real(r4),allocatable      :: slon(:),slat(:)
real(r4)                  :: ptlat,ptlon
integer(i4)               :: i,j,k
integer(i4),allocatable   :: ob_grp_present(:)
integer(i4)               :: nob_grp
integer(i4)               :: istat
logical(bl)               :: isPresent
integer(i4)               :: stat

real(r4),allocatable      :: sss(:,:),err(:,:)
real(r4),allocatable      :: l2sss_val(:,:),l2sss_err(:,:),l2sss_inov(:,:)

nob_grp=9



allocate(l2sss_val(nx,ny))
allocate(l2sss_err(nx,ny))
allocate(l2sss_inov(nx,ny))
allocate(ob_grp_present(nob_grp))

cobsFile=trim(cobs_location)//analysis_date(1:4)//"/tsis_cobs_"//analysis_date//".nc"

inquire (file=cobsFile,exist=lexist)

 if(lexist) then

         call nciopn(cobsFile,fid)
         call ncioiv(cobsFile,fid,"l2sss_val",stat)
   if(stat==0) then
         call ncioin(cobsFile,fid,"l4obs_lon",gnx)
         call ncioin(cobsFile,fid,"l4obs_lat",gny)

         allocate(glon(gnx))
         allocate(glat(gny))

         call nciorv(cobsFile,fid,"l4obs_lon",glon)
         call nciorv(cobsFile,fid,"l4obs_lat",glat)

         glat(1)=-90.0
         glat(gny)=90.0
         glon(1)=-180.0
         glon(gnx)=180.0


         rs=ridx(glon,lnmn)
         re=ridx(glon,lnmx)
         ss=ridx(glat,ltmn)
         se=ridx(glat,ltmx)

         !print *, lnmn,lnmx,ltmn,ltmx
         !print *, rs,re,ss,se
         !stop

         snx=(re-rs)+1
         sny=(se-ss)+1
         is=int(rs)
         js=int(ss)

         allocate(slon(snx))
         allocate(slat(sny))
         allocate(sss(snx,sny),err(snx,sny))
         slon=glon(rs:re)
         slat=glat(ss:se)

         call nciorv(cobsFile,fid,"l2sss_val",sss,[is,js],[snx,sny])
         !call nciora(cobsFile,fid,"l2sss_val","_FillValue",fill_value_sss)
         call nciorv(cobsFile,fid,"l2sss_err",err,[is,js],[snx,sny])
         !call nciora(cobsFile,fid,"l2sss_err","_FillValue",fill_value_err)

         call nciocl(cobsFile,fid)


                 ! extend sla


         !call hextend(sss,snx,sny,50,spval)
         !call hextend(err,snx,sny,50,spval)
         call intp_fld (snx,sny,nx,ny,slon,slat,mlon,mlat,sss,l2sss_val)
         call intp_fld (snx,sny,nx,ny,slon,slat,mlon,mlat,err,l2sss_err)

         l2sss_inov=l2sss_val-fsss


        where(mdepth>=spval .or. abs(l2sss_val)>45.0 .or. abs(l2sss_err)>45.0 )
                 l2sss_val=spval
                 l2sss_err=spval
                 l2sss_inov=spval
         end where


!         write(*,*) "....l2 sss min/max ",minval(l2sss_val,mask=l2sss_val<spval), maxval(l2sss_val,mask=l2sss_val<spval)

         inFile=trim(tsis_obs_location)//"tsis_obs_"//trim(pfx)//"_"//analysis_date//".nc"
         call nciopn(inFile,fid,'w')
         call nciowv(inFile,fid,"l2sss",l2sss_val)
         call nciowv(inFile,fid,"l2sss_err",l2sss_err)
         call nciorv(inFile,fid,"obsgrp",obsgrp)
         obsgrp(l2_sss)=1
         call nciowv(inFile,fid,"obsgrp",obsgrp)
         call nciocl(inFile,fid)

         inFile=trim(tsis_obs_location)//"tsis_inov_"//trim(pfx)//"_"//analysis_date//".nc"

         call nciopn(inFile,fid,'w')
         call nciowv(inFile,fid,"l2sss_inov",l2sss_inov)

         call nciocl(inFile,fid)



         else
                 call nciocl(cobsFile,fid)
         endif ! l4sla exists


 else

   write(*,*) "....no l2sss obs....."

 end if

end subroutine









end module 
