module mpvel

use mkinds
use mconstants
use mglobals
use mobs
use mgrid
use mlinint
use msplint
use msearch
use mdates
use mstate
use msstat
use mminfo
use mobsio
use mfld


contains 

! prep_l2sss

subroutine prep_drifters()

        character(10)                :: wanted_date
character(10)                :: cdtg_w
character(:),allocatable     :: cobsFile,rocisFile,inFile
logical(bl)                  :: lexist,rocis_exist
real(r4),allocatable         :: dfu(:)
real(r4),allocatable         :: dfv(:)
real(r4),allocatable         :: dftime(:)
real(r4),allocatable         :: dflon(:)
real(r4),allocatable         :: dflat(:)
! model grid
real(r4),allocatable         :: ug(:,:)
real(r4),allocatable         :: vg(:,:)
integer(i4),allocatable         :: nv(:,:)
real(r4),allocatable         :: uinov(:,:)
real(r4),allocatable         :: vinov(:,:)
character(11)                :: drifter_date
character(8)                 :: drifter_time
integer(i4)                  :: nlimit,year,month,day,hr,mn,ntd,nd,ihour,nvalid,nrocis,ndrifter
real(r4)                     :: mtime,stime
real(r4)                     :: plon,plat,ud,vd
integer(i4)                  :: i,j,k
integer(i4)                  :: ix,jy,istat
integer(i4)                  :: twin
real(r4)                  :: wsday,wday





call cymd2hday(analysis_date,wday)
twin=3.0
call read_obs_location()
allocate(ug(nx,ny))
allocate(vg(nx,ny))
allocate(uinov(nx,ny))
allocate(vinov(nx,ny))
allocate(nv(nx,ny))

ug=0.0
vg=0.0
nv=0

do k=-twin,twin
  wsday=wday+real(k,r4)
  call hday2cymd(wsday,wanted_date)
  cobsFile=trim(cobs_location)//analysis_date(1:4)//"/"//"tsis_cobs_"//wanted_date//".nc"
  inquire (file=cobsFile,exist=lexist)

 if(lexist) then

call nciopn(cobsFile,fid)
call ncchkv(cobsFile,fid,"drifter",istat)
if(istat==0) then
call ncioin(cobsFile,fid,"drifter",ndrifter)
allocate(dfu(ndrifter))
allocate(dfv(ndrifter))
allocate(dflon(ndrifter))
allocate(dflat(ndrifter))
call nciorv(cobsFile,fid,"drifter_lon",dflon)
call nciorv(cobsFile,fid,"drifter_lat",dflat)
call nciorv(cobsFile,fid,"drifter_u",dfu)
call nciorv(cobsFile,fid,"drifter_v",dfv)
call nciocl(cobsFile,fid)

do i=1,ndrifter
!   write(*,'(I5,5F12.2)') i,dflon(i),dflat(i),dfu(i),dfv(i)
   ix=int(ridx(mlon(:,1),dflon(i)))
   jy=int(ridx(mlat(1,:),dflat(i)))

   if(ix/=-99.0 .and. jy/=-99.0) then
     ug(ix,jy)=ug(ix,jy) + dfu(i)
     vg(ix,jy)=vg(ix,jy) + dfv(i)
     nv(ix,jy)=nv(ix,jy)+1
   endif
enddo

deallocate(dfu,dfv,dflon,dflat)
endif

endif
enddo


where(nv>=1)
        ug=ug/nv
        vg=vg/nv
elsewhere
        ug=spval
        vg=spval
end where

where(ug<spval .and. vg<spval .and. fuvl(:,:,1)<spval .and. fvvl(:,:,1)<spval)
        uinov=ug-fuvl(:,:,1)
        vinov=vg-fvvl(:,:,1)
else where
        uinov=spval
        vinov=spval
end where


if(maxval(nv)>0) then
         write(*,*) ".... drifter count  min/max ",sum(nv), minval(nv), maxval(nv)
         write(*,*) ".... uvel  min/max ",minval(ug,mask=ug<spval), maxval(ug,mask=ug<spval)
         write(*,*) ".... uvel  min/max ",minval(vg,mask=vg<spval), maxval(vg,mask=vg<spval)

          inFile=trim(tsis_obs_location)//"tsis_obs_"//trim(pfx)//"_"//analysis_date//".nc"
          call nciopn(inFile,fid,'w')
          call nciowv(inFile,fid,"uos",ug)
          call nciowv(inFile,fid,"vos",vg)
          call nciorv(inFile,fid,"obsgrp",obsgrp)
          obsgrp(l2_suv)=1
          call nciowv(inFile,fid,"obsgrp",obsgrp)
          call nciocl(inFile,fid)


          inFile=trim(tsis_obs_location)//"tsis_inov_"//trim(pfx)//"_"//analysis_date//".nc"
          call nciopn(inFile,fid,'w')
          call nciowv(inFile,fid,"uos_inov",uinov)
          call nciowv(inFile,fid,"vos_inov",vinov)
          call nciocl(inFile,fid)

endif ! variable present or not

end subroutine









end module 
