module  msmos

use mkinds
use mncio
use mconstants
use mdates
use mobs
use mtsclim
use mfld

implicit none

integer(i4)                             :: sss_nx,sss_ny,sss_nt
real(r4),allocatable                    :: sss_lon(:),sss_lat(:),sss_time(:)

real(r4),allocatable                    :: sss_a(:,:),err_a(:,:)
real(r4),allocatable                    :: sss_d(:,:),err_d(:,:)
real(r4),allocatable                    :: sss(:,:),err(:,:)
real(r4),allocatable                    :: l2sss_val(:,:),l2sss_err(:,:)

contains


        subroutine smos2cobs(wanted_date,iflag)

implicit none


character(10)                           :: wanted_date
integer(i4)                             :: iflag

character(:),allocatable                :: smosFile_a,smosFile_d,filename
integer(i4)                             :: i,j,k
logical(bl)                             :: lexist_a,lexist_d

call read_obs_location()


smosFile_a=trim(l2sss_data_location)//wanted_date(1:4)//"/smosa_sss_l2_"//wanted_date(1:8)//".nc"
smosFile_d=trim(l2sss_data_location)//wanted_date(1:4)//"/smosd_sss_l2_"//wanted_date(1:8)//".nc"

inquire(file=smosFile_a,exist=lexist_a)
inquire(file=smosFile_d,exist=lexist_d)

if(lexist_a) then
call read_sss(smosFile_a,"a")
endif

if(lexist_d) then
call read_sss(smosFile_d,"d")
endif


allocate(l2sss_val(cnx,cny))
allocate(l2sss_err(cnx,cny))
allocate(sss(sss_nx,sss_ny))
allocate(err(sss_nx,sss_ny))

if(lexist_a .and. not(lexist_d)) then
        sss=sss_a
        err=err_a
else if (lexist_d .and. not(lexist_a)) then
        sss=sss_d
        err=err_d
else if (lexist_a .and. lexist_d) then
sss=sss_a
err=err_a


do j=1,sss_ny
 do i=1,sss_nx
 if(sss_a(i,j)>=spval .and. sss_d(i,j)<spval) then
         sss(i,j)=sss_d(i,j)
 else if (sss(i,j)<spval .and. sss_d(i,j)<spval) then
         sss(i,j)=0.5*(sss(i,j)+sss_d(i,j))
 endif

 enddo
 enddo


do j=1,sss_ny
 do i=1,sss_nx

 if(err(i,j)>=spval .and. err_d(i,j)<spval) then
         err(i,j)=err_d(i,j)
 else if (err(i,j)<spval .and. err_d(i,j)<spval) then
         err(i,j)=0.5*(err(i,j)+err_d(i,j))
 endif   

 enddo
 enddo


 endif !

if(lexist_a .or. lexist_d) then

sss_lon(1)=clon(1)
sss_lon(sss_nx)=clon(cnx)
sss_lat(1)=clat(1)
sss_lat(sss_ny)=clat(cny)

call intp_fld1 (sss_nx,sss_ny,cnx,cny,sss_lon,sss_lat,clon,clat,sss,l2sss_val)
call intp_fld1 (sss_nx,sss_ny,cnx,cny,sss_lon,sss_lat,clon,clat,err,l2sss_err)

where(l2sss_val<0.0 .or. l2sss_val>45.0) 
        l2sss_val=spval
        l2sss_err=spval
end where

!    cobsFile=trim(cobs_location)//wanted_date(1:4)//"/tsis_cobs_"//wanted_date//".nc"
!    call cobs_add_l4sss(cobsFile,cnx,cny,l4sss,l4err)
    iflag=0
    Write(*,*) "....SMOS salinity A and/or D swathes ....", lexist_a,lexist_d
else
        iflag=-1
    Write(*,*) "....no L2 SMOS salinity ...."


endif

end subroutine


subroutine read_sss(smosFile,adflag)


    character(*)  :: smosFile
    character(1)   :: adflag
    real(r4)       :: sss_v_scl,sss_v_off
    real(r4)       :: sss_e_scl,sss_e_off
    real(r4)       :: sss_qf_scl,sss_qf_off
    real(r4)       :: sss_v_flag,sss_e_flag
    real(r4),allocatable       :: sss_v(:,:),sss_e(:,:),sss_qf(:,:)

    call nciopn(smosFile,fid)
    call ncioin(smosFile,fid,"lon",sss_nx)
    call ncioin(smosFile,fid,"lat",sss_ny)
    call ncioin(smosFile,fid,"time",sss_nt)

    if (.not. allocated(sss_lon)) allocate(sss_lon(sss_nx))
    if (.not. allocated(sss_lat)) allocate(sss_lat(sss_ny))
    if (.not. allocated(sss_time))allocate(sss_time(sss_nt))

    allocate(sss_v(sss_nx,sss_ny))
    allocate(sss_e(sss_nx,sss_ny))
    allocate(sss_qf(sss_nx,sss_ny))

    call nciorv(smosFile,fid,"lon",sss_lon)
    call nciorv(smosFile,fid,"lat",sss_lat)
    call nciorv(smosFile,fid,"time",sss_time)    
    call nciorv(smosFile,fid,"Sea_Surface_Salinity_Rain_Corrected",sss_v)
    call nciora(smosFile,fid,"Sea_Surface_Salinity_Rain_Corrected","scale_factor",sss_v_scl)
    call nciora(smosFile,fid,"Sea_Surface_Salinity_Rain_Corrected","add_offset",sss_v_off)
    call nciora(smosFile,fid,"Sea_Surface_Salinity_Rain_Corrected","_FillValue",sss_v_flag)
    call nciorv(smosFile,fid,"Sea_Surface_Salinity_Error",sss_e)
    call nciora(smosFile,fid,"Sea_Surface_Salinity_Error","scale_factor",sss_e_scl)
    call nciora(smosFile,fid,"Sea_Surface_Salinity_Error","add_offset",sss_e_off)
    call nciora(smosFile,fid,"Sea_Surface_Salinity_Rain_Corrected","_FillValue",sss_e_flag)
    call nciorv(smosFile,fid,"Sea_Surface_Salinity_QC",sss_qf)
    call nciocl(smosFile,fid)


    where(sss_v>sss_v_flag)
        sss_v=sss_v*sss_v_scl+sss_v_off
    else where
        sss_v=spval
    end where

    where(sss_e>sss_e_flag)
        sss_e=sss_e*sss_e_scl+sss_e_off
    else where
        sss_e=spval
    end where

    where(sss_qf==1)
        sss_v=spval
        sss_e=spval
   end where

   where(sss_v<0.0 .or. sss_v>45.0)
        sss_v=spval
        sss_e=spval
   end where

   if(adflag .eq. "a") then

           allocate(sss_a(sss_nx,sss_ny))
           allocate(err_a(sss_nx,sss_ny))
           sss_a=sss_v
           err_a=sss_e
   else if (adflag .eq. "d") then
           allocate(sss_d(sss_nx,sss_ny))
           allocate(err_d(sss_nx,sss_ny))
           sss_d=sss_v
           err_d=sss_e
   endif

   deallocate(sss_v,sss_e,sss_qf)


end subroutine


















end module
