module msproject
use mkinds
use mconstants
use mglobals
use msstat

contains

subroutine set_vproject()

      NAMELIST /vproject/hproject

        OPEN(21,FILE='tsis.nlist')
        READ(21,NML=vproject)
        CLOSE(21)

end subroutine

subroutine project_sst(nx,ny,nl,mdepth,iv,fv,fpin,avscl)

integer(i4)    :: nx,ny,nl
real(r4)       :: fv(nx,ny,nl)
real(r4)       :: mdepth(nx,ny)
real(r4)       :: fpin(nx,ny,nl+1)
real(r4)       :: iv(nx,ny)
real(r4)       :: avscl(nx,ny)
integer(i4)    :: i,j,k
real(r4)       :: vscl
real(r4),parameter :: maxdd=500.0
do k=1,nl
 do j=1,ny
  do i=1,nx
   if(mdepth(i,j)<spval .and. mdepth(i,j)>cr_depth .and. fv(i,j,k)<spval) then
     ! limit projection to max 500m
       vscl=min(avscl(i,j),maxdd)
       fv(i,j,k)=fv(i,j,k)+iv(i,j)*exp(-fpin(i,j,k)/vscl)
      ! if(i==600 .and. j==360) then
      !   print *, k,fpin(i,j,k),exp(-fpin(i,j,k)/vscl),vscl
      ! endif
   endif
  enddo
 enddo
enddo

end subroutine

subroutine project_svel(nx,ny,nl,mdepth,iu,iv,fu,fv,fpin)
implicit none
integer(i4)    :: nx,ny,nl
real(r4)       :: fu(nx,ny,nl)
real(r4)       :: fv(nx,ny,nl)
real(r4)       :: mdepth(nx,ny)
real(r4)       :: fpin(nx,ny,nl+1)
real(r4)       :: iu(nx,ny)
real(r4)       :: iv(nx,ny)
real(r4)       :: avscl(nx,ny)
integer(i4)    :: i,j,k
real(r4)       :: vdpth_scl
real(r4),parameter :: maxdd=500.0
!
fu=0.0
fv=0.0
! apply u and v

            do j=2,ny-1
              do i=2,nx-1
                 if(mdepth(i,j)<spval .and. mdepth(i+1,j)<spval) then
                    iu(i,j)=0.5*(iu(i,j)+iu(i+1,j))
                 else
                    iu(i,j)=0.0
                 endif
             enddo
            enddo

            !print *, maxloc(duinc)


            do j=2,ny-1
             do i=2,nx-1
               if(mdepth(i,j)<spval .and. mdepth(i,j+1)<spval) then
                   iv(i,j)=0.5*(iv(i,j)+iv(i,j+1))
                 else
                 iv(i,j)=0.0
              endif
             enddo
            enddo

            do j=2,ny-1
             do i=2,nx-1

               if(mdepth(i,j)<spval .and. mdepth(i,j+1)<spval) then
               vdpth_scl=min(mdepth(i,j),maxdd)
               do k=1,nl
                   fu(i,j,k)=iu(i,j)*exp(-fpin(i,j,k)/vdpth_scl)
               enddo
              endif
              enddo
             enddo

               do j=2,ny-1
             do i=2,nx-1

               if(mdepth(i,j)<spval .and. mdepth(i,j+1)<spval) then
               vdpth_scl=min(mdepth(i,j),maxdd)
               do k=1,nl
                   fv(i,j,k)=iv(i,j)*exp(-fpin(i,j,k)/vdpth_scl)
               enddo
              endif
              enddo
             enddo

end subroutine

subroutine project_hdp(nx,ny,nl,mdepth,dpin,iv,dpout)

implicit none
integer(i4)    :: nx,ny,nl
real(r4)       :: dpin(:,:,:)
real(r4)       :: dpout(:,:,:)
real(r4)       :: iv(:,:)
real(r4)       :: mdepth(:,:)

real(r4),allocatable       :: hdp(:,:,:)
integer(i4)    :: i,j,k


              allocate(hdp(nx,ny,nl))

              call nciopn(tsis_stat_File,fid)
              call nciorv(tsis_stat_File,fid,"hdp",hdp)
              call nciocl(tsis_stat_File,fid)

              do j=1,ny
              do i=1,nx
               if(mdepth(i,j) <hspval .and. mdepth(i,j)>cr_depth) then
               do k=1,nl
                dpout(i,j,k)=iv(i,j)*hdp(i,j,k)+dpin(i,j,k)
               enddo
               endif
              enddo
             enddo

end subroutine



















end module        
