MODULE mstate
USE mkinds
USE mconstants
USE mncio
USE mgrid
USE mhycom


IMPLICIT NONE

! partial states

REAL(r4), ALLOCATABLE         :: fssh(:,:)
REAL(r4), ALLOCATABLE         :: fsst(:,:)
REAL(r4), ALLOCATABLE         :: fsss(:,:)
REAL(r4), ALLOCATABLE         :: fmld(:,:)
REAL(r4), ALLOCATABLE         :: fuba(:,:)
REAL(r4), ALLOCATABLE         :: fvba(:,:)
REAL(r4), ALLOCATABLE         :: fpba(:,:)
REAL(r4), ALLOCATABLE         :: fuvl(:,:,:)
REAL(r4), ALLOCATABLE         :: fvvl(:,:,:)
REAL(r4), ALLOCATABLE         :: ftem(:,:,:)
REAL(r4), ALLOCATABLE         :: fsal(:,:,:)
REAL(r4), ALLOCATABLE         :: fden(:,:,:)
REAL(r4), ALLOCATABLE         :: fthk(:,:,:)
REAL(r4), ALLOCATABLE         :: fpin(:,:,:)
REAL(r4), ALLOCATABLE         :: fmgp(:,:,:)
REAL(r4), ALLOCATABLE         :: fpsikk(:,:,:)
REAL(r4), ALLOCATABLE         :: fthkk(:,:,:)
REAL(r4), ALLOCATABLE         :: work3d(:,:,:)
REAL(r4), ALLOCATABLE         :: fcst(:,:)
REAL(r4), ALLOCATABLE         :: idx(:,:)
REAL(r4), ALLOCATABLE         :: fathk(:,:,:)
REAL(r4), ALLOCATABLE         :: ists(:,:)
integer(i4),allocatable       :: mskmr(:,:,:)

REAL(r4), ALLOCATABLE         :: xf3(:,:,:)
REAL(r4), ALLOCATABLE         :: xa3(:,:,:)
REAL(r4), ALLOCATABLE         :: xf1(:,:)
REAL(r4), ALLOCATABLE         :: xa1(:,:)
REAL(r4), ALLOCATABLE         :: b1(:,:)
REAL(r4), ALLOCATABLE         :: inc(:,:,:,:,:)
REAL(r4), ALLOCATABLE         :: uinc(:,:)
REAL(r4), ALLOCATABLE         :: vinc(:,:)
REAL(r4), ALLOCATABLE         :: hinc(:,:)
REAL(r4), ALLOCATABLE         :: hdp(:,:,:)

! stz
REAL(r4), ALLOCATABLE         :: zuvl(:,:,:)
REAL(r4), ALLOCATABLE         :: zvvl(:,:,:)
REAL(r4), ALLOCATABLE         :: ztem(:,:,:)
REAL(r4), ALLOCATABLE         :: zsal(:,:,:)

! analyzed state

REAL(r4), TARGET, ALLOCATABLE :: assh(:,:)
REAL(r4), TARGET, ALLOCATABLE :: asst(:,:)
REAL(r4), ALLOCATABLE         :: asss(:,:)
REAL(r4), ALLOCATABLE         :: amld(:,:)
REAL(r4), ALLOCATABLE         :: auba(:,:)
REAL(r4), ALLOCATABLE         :: avba(:,:)
REAL(r4), ALLOCATABLE         :: apba(:,:)
REAL(r4), ALLOCATABLE         :: auvl(:,:,:)
REAL(r4), ALLOCATABLE         :: avvl(:,:,:)
REAL(r4), ALLOCATABLE         :: atem(:,:,:)
REAL(r4), ALLOCATABLE         :: asal(:,:,:)
REAL(r4), ALLOCATABLE         :: aden(:,:,:)
REAL(r4), ALLOCATABLE         :: athk(:,:,:)
REAL(r4), ALLOCATABLE         :: apin(:,:,:)
REAL(r4), ALLOCATABLE         :: apsikk(:,:,:)
REAL(r4), ALLOCATABLE         :: athkk(:,:,:)
REAL(r4), ALLOCATABLE         :: ua(:,:)
REAL(r4), ALLOCATABLE         :: va(:,:)

! int/tmp state

REAL(r4), TARGET, ALLOCATABLE :: issh(:,:)
REAL(r4), TARGET, ALLOCATABLE :: isst(:,:)
REAL(r4), ALLOCATABLE         :: isss(:,:)
REAL(r4), ALLOCATABLE         :: imld(:,:)
REAL(r4), ALLOCATABLE         :: iuba(:,:)
REAL(r4), ALLOCATABLE         :: ivba(:,:)
REAL(r4), ALLOCATABLE         :: ipba(:,:)
REAL(r4), ALLOCATABLE         :: iuvl(:,:,:)
REAL(r4), ALLOCATABLE         :: ivvl(:,:,:)
REAL(r4), ALLOCATABLE         :: item(:,:,:)
REAL(r4), ALLOCATABLE         :: isal(:,:,:)
REAL(r4), ALLOCATABLE         :: iden(:,:,:)
REAL(r4), ALLOCATABLE         :: ithk(:,:,:)
REAL(r4), ALLOCATABLE         :: iathk(:,:,:)
REAL(r4), ALLOCATABLE         :: ipin(:,:,:)
REAL(r4), ALLOCATABLE         :: imgp(:,:,:)
REAL(r4), ALLOCATABLE         :: ipsikk(:,:,:)
REAL(r4), ALLOCATABLE         :: ithkk(:,:,:)


! new variables for substate

REAL(r4), ALLOCATABLE         :: f3d(:,:,:)
REAL(r4), ALLOCATABLE         :: a3d(:,:,:)

!
REAL(r4), ALLOCATABLE         :: dpin(:,:,:)
REAL(r4), ALLOCATABLE         :: dpout(:,:,:)
REAL(r4), ALLOCATABLE         :: dpmixl(:,:)
REAL(r4), ALLOCATABLE         :: den(:,:,:)


REAL(r4), ALLOCATABLE         :: bv(:,:)
REAL(r4), ALLOCATABLE         :: ev(:,:)
REAL(r4), ALLOCATABLE         :: iv(:,:)
REAL(r4), ALLOCATABLE         :: cv(:,:)
REAL(r4), ALLOCATABLE         :: vv(:,:)
REAL(r4), ALLOCATABLE         :: fv(:,:)

REAL(r4), ALLOCATABLE         :: b3(:,:,:,:)
REAL(r4), ALLOCATABLE         :: e3(:,:,:,:)
REAL(r4), ALLOCATABLE         :: i3(:,:,:,:)
REAL(r4), ALLOCATABLE         :: c3(:,:,:,:)
REAL(r4), ALLOCATABLE         :: v3(:,:,:,:)
REAL(r4), ALLOCATABLE         :: f3(:,:,:,:)

REAL(r4), ALLOCATABLE         :: sb3(:,:,:,:)
REAL(r4), ALLOCATABLE         :: se3(:,:,:,:)
REAL(r4), ALLOCATABLE         :: si3(:,:,:,:)
REAL(r4), ALLOCATABLE         :: sc3(:,:,:,:)
REAL(r4), ALLOCATABLE         :: sv3(:,:,:,:)
REAL(r4), ALLOCATABLE         :: sf3(:,:,:,:)

REAL(r4), ALLOCATABLE         :: sla_offset(:,:)
REAL(r4), ALLOCATABLE         :: dhinc(:,:)
REAL(r4), ALLOCATABLE         :: duinc(:,:)
REAL(r4), ALLOCATABLE         :: dvinc(:,:)
REAL(r4), ALLOCATABLE         :: sst_inc(:,:)
REAL(r4), ALLOCATABLE         :: sla_inc(:,:)
! model type

!character(:),allocatable      :: FCFileName
!character(:),allocatable      :: fcmodel
!character(:),allocatable      :: anlfileName
!character(:),allocatable      :: mpfx
!logical(bl)                   :: fcst_file_out
!logical(bl)                   :: lglb

CONTAINS

SUBROUTINE malloc_sub_state(start,count)
IMPLICIT NONE
INTEGER(i4)               :: start(3)
INTEGER(i4)               :: count(3)

!ALLOCATE(a3d(count(1),count(2),count(3)))
!ALLOCATE(f3d(count(1),count(2),count(3)))
ALLOCATE(sla_offset(count(1),count(2)))
ALLOCATE(fpin(count(1),count(2),count(3)+1))
ALLOCATE(dhinc(count(1),count(2)))
ALLOCATE(duinc(count(1),count(2)))
ALLOCATE(dvinc(count(1),count(2)))
ALLOCATE(sst_inc(count(1),count(2)))

END SUBROUTINE

SUBROUTINE malloc_lilo(start,count)
IMPLICIT NONE
INTEGER(i4)               :: start(3)
INTEGER(i4)               :: count(3)

ALLOCATE(den(count(1),count(2),count(3)))
ALLOCATE(dpin(count(1),count(2),count(3)))
ALLOCATE(dpout(count(1),count(2),count(3)))
ALLOCATE(dpmixl(count(1),count(2)))
END SUBROUTINE


SUBROUTINE free_lilo()
IMPLICIT NONE
deALLOCATE(dpin,den,dpout,dpmixl)
END SUBROUTINE


!SUBROUTINE malloc_XA(start,count)
!IMPLICIT NONE

!INTEGER(i4)               :: start(3)
!INTEGER(i4)               :: count(3)

!ALLOCATE(ssh_inc(count(1),count(2)))
!ALLOCATE(sst_inc(count(1),count(2)))
!ALLOCATE(pin_inc(count(1),count(2),count(3)))
!ALLOCATE(tem_inc(count(1),count(2),count(3)))
!ALLOCATE(sal_inc(count(1),count(2),count(3)))

!END SUBROUTINE

SUBROUTINE malloc_avectors(start,count)

IMPLICIT NONE
INTEGER(i4)               :: start(3)
INTEGER(i4)               :: count(3)

allocate(fv(count(1),count(2)))
allocate(bv(count(1),count(2)))
allocate(ev(count(1),count(2)))
allocate(iv(count(1),count(2)))
allocate(cv(count(1),count(2)))
allocate(vv(count(1),count(2)))

allocate(b3(count(1),count(2),count(3),3))
allocate(f3(count(1),count(2),count(3),3))
allocate(v3(count(1),count(2),count(3),3))
allocate(e3(count(1),count(2),count(3),3))
allocate(i3(count(1),count(2),count(3),3))

allocate(sb3(count(1),count(2),3,1))
allocate(sf3(count(1),count(2),3,1))
allocate(sv3(count(1),count(2),3,1))
allocate(se3(count(1),count(2),3,1))
allocate(si3(count(1),count(2),3,1))

!allocate(xf3(count(1),count(2),3))
!allocate(xa3(count(1),count(2),3))
!ALLOCATE(a3d(count(1),count(2),count(3)))
!ALLOCATE(f3d(count(1),count(2),count(3)))

END SUBROUTINE

SUBROUTINE malloc_state(start,count)
IMPLICIT NONE
INTEGER(i4)               :: start(3)
INTEGER(i4)               :: count(3)

ALLOCATE(fssh(count(1),count(2)))
ALLOCATE(fsst(count(1),count(2)))
ALLOCATE(fsss(count(1),count(2)))
ALLOCATE(fmld(count(1),count(2)))
ALLOCATE(fuba(count(1),count(2)))
ALLOCATE(fvba(count(1),count(2)))
ALLOCATE(fpba(count(1),count(2)))
ALLOCATE(fuvl(count(1),count(2),count(3)))
ALLOCATE(fvvl(count(1),count(2),count(3)))
ALLOCATE(fsal(count(1),count(2),count(3)))
ALLOCATE(ftem(count(1),count(2),count(3)))
ALLOCATE(fthk(count(1),count(2),count(3)))
ALLOCATE(fden(count(1),count(2),count(3)))
ALLOCATE(fmgp(count(1),count(2),count(3)))
ALLOCATE(fpsikk(count(1),count(2),2))
ALLOCATE(fthkk(count(1),count(2),2))
ALLOCATE(fpin(count(1),count(2),count(3)+1))
ALLOCATE(apin(count(1),count(2),count(3)+1))
ALLOCATE(atem(count(1),count(2),count(3)))
ALLOCATE(asal(count(1),count(2),count(3)))
ALLOCATE(athk(count(1),count(2),count(3)))
ALLOCATE(assh(count(1),count(2)))
allocate(sla_inc(count(1),count(2)))
allocate(sla_offset(count(1),count(2)))
allocate(asst(count(1),count(2)))
allocate(duinc(count(1),count(2)))
allocate(dvinc(count(1),count(2)))
ALLOCATE(sst_inc(count(1),count(2)))
ALLOCATE(mskmr(count(1),count(2),count(3)))
ALLOCATE(fathk(count(1),count(2),count(3)))
!allocate(work3d(count(1),count(2),count(3)))
END SUBROUTINE

!subroutine malloc_avectors()
!implicit none

!allocate(xf3(count(1),count(2),3))
!allocate(xa3(count(1),count(2),3))
!allocate(b3(count(1),count(2),3))
!allocate(xf1(count(1),count(2)))
!allocate(xa1(count(1),count(2)))
!allocate(b1(count(1),count(2)))
!allocate(ists(count(1),count(2)))
!allocate(bv(count(1),count(2)))
!allocate(ev(count(1),count(2)))
!allocate(vv(count(1),count(2)))
!allocate(iv(count(1),count(2)))
!allocate(fcst(count(1),count(2)))
!allocate(work2d(count(1),count(2)))
!allocate(inc(count(1),count(2),1,1,4))
!end subroutine malloc_avectors        

SUBROUTINE malloc_astate(start,count)
IMPLICIT NONE
INTEGER(i4)               :: start(3)
INTEGER(i4)               :: count(3)

!ALLOCATE(assh(count(1),count(2)))
!ALLOCATE(asst(count(1),count(2)))
!ALLOCATE(asss(count(1),count(2)))
ALLOCATE(amld(count(1),count(2)))
ALLOCATE(auba(count(1),count(2)))
ALLOCATE(avba(count(1),count(2)))
!ALLOCATE(apba(count(1),count(2)))
ALLOCATE(auvl(count(1),count(2),count(3)))
ALLOCATE(avvl(count(1),count(2),count(3)))
ALLOCATE(asal(count(1),count(2),count(3)))
ALLOCATE(atem(count(1),count(2),count(3)))
ALLOCATE(athk(count(1),count(2),count(3)))
!ALLOCATE(fathk(count(1),count(2),count(3)))
!ALLOCATE(aden(count(1),count(2),count(3)))
!ALLOCATE(amgp(count(1),count(2),count(3)))
!ALLOCATE(apsikk(count(1),count(2),2))
!ALLOCATE(athkk(count(1),count(2),2))
!ALLOCATE(apin(count(1),count(2),count(3)+1))
atem=0.
asal=0.
athk=0.
!aden=0.
!assh=0.
!apin=0.
!auvl=0.
!avvl=0.
!auba=0.
!avba=0.
!work2d=0.
END SUBROUTINE

SUBROUTINE malloc_istate(start,count)
IMPLICIT NONE
INTEGER(i4)               :: start(3)
INTEGER(i4)               :: count(3)

ALLOCATE(issh(count(1),count(2)))
ALLOCATE(isst(count(1),count(2)))
ALLOCATE(isss(count(1),count(2)))
ALLOCATE(imld(count(1),count(2)))
ALLOCATE(iuba(count(1),count(2)))
ALLOCATE(ivba(count(1),count(2)))
ALLOCATE(ipba(count(1),count(2)))
ALLOCATE(iuvl(count(1),count(2),count(3)))
ALLOCATE(ivvl(count(1),count(2),count(3)))
ALLOCATE(isal(count(1),count(2),count(3)))
ALLOCATE(item(count(1),count(2),count(3)))
ALLOCATE(ithk(count(1),count(2),count(3)))
ALLOCATE(iathk(count(1),count(2),count(3)))
ALLOCATE(iden(count(1),count(2),count(3)))
ALLOCATE(imgp(count(1),count(2),count(3)))
ALLOCATE(ipsikk(count(1),count(2),2))
ALLOCATE(ithkk(count(1),count(2),2))
ALLOCATE(ipin(count(1),count(2),count(3)+1))
item=0.
isal=0.
ithk=0.
iden=0.
issh=0.
ipin=0.
iuvl=0.
ivvl=0.
iuba=0.
ivba=0.
work3d=0.
END SUBROUTINE

SUBROUTINE free_state()
IMPLICIT NONE

DEALLOCATE (fssh, fsst, fsss, fmld, fuba, fvba, fpba) 
DEALLOCATE (fuvl, fvvl, fsal, ftem, fthk, fden, fpin)
DEALLOCATE (fmgp,fpsikk,fthkk,apin,atem,asal,athk,assh)

END SUBROUTINE

SUBROUTINE free_astate()
IMPLICIT NONE

DEALLOCATE (assh, asst, asss, auba, avba)
DEALLOCATE (auvl, avvl, asal, atem, athk, aden, apin)

END SUBROUTINE

SUBROUTINE getFCstate(FileName,fcmodel,c2r)
USE mdates
USE mhycom

IMPLICIT NONE
CHARACTER(*)              :: FileName
CHARACTER(*)              :: fcmodel
logical(bl)               :: lexist
integer(i4)               :: c2r

IF (fcmodel .eq. 'hycom') THEN
 CALL readrst(FileName,nx,ny,nl,kapref,pref,thbase,thref,thflag,msk3d,fssh,fsst,&
         fsss,fmld,fuba,fvba,fpba,fuvl,fvvl,fthk,ftem,fsal,fden,fthkk,fpsikk,fmgp,fpin,c2r)
ENDIF

END SUBROUTINE

SUBROUTINE putFCstate(FileName,fcmodel)
USE mdates
USE mhycom

IMPLICIT NONE
CHARACTER(*)              :: FileName
CHARACTER(*)              :: fcmodel


IF (fcmodel .eq. 'hycom') THEN
     CALL writeHYCOMXF(FileName,nx,ny,nl,msk3d,mlon,mlat,mlayer,mdepth,fssh,&
             fmld,fuba,fvba,fuvl,fvvl,fthk,ftem,fsal,fden)
   ENDIF

END SUBROUTINE

SUBROUTINE putFCZstate(FileName,fcmodel,time)
USE mdates
USE mhycom

IMPLICIT NONE
CHARACTER(*)              :: FileName
CHARACTER(*)              :: fcmodel
real(r8)                  :: time


IF (fcmodel .eq. 'hycom') THEN
     CALL writeHYCOMXFZ(FileName,nx,ny,nl,mlon,mlat,mlayer,time,mdepth,fssh,&
             fmld,fuvl,fvvl,fthk,ftem,fsal)
   ENDIF

END SUBROUTINE


subroutine readXF(FileName,var)

character(*)             :: var
character(*)             :: FileName
integer :: k


!Read XF

call nciopn(filename,fid)
if(var=="ssh") then
 call nciorv(filename,fid,"ssh",fv)
else if(var=="tem") then
 call nciorv(filename,fid,"tem",f3d)
else if(var=="sal") then
 call nciorv(filename,fid,"sal",f3d)
else if(var=="thk" .or. var=="pin") then
call nciorv(filename,fid,"thk",f3d)
else if(var=="uvl") then
 call nciorv(filename,fid,"uvl",f3d)
else if(var=="vvl") then
 call nciorv(filename,fid,"vvl",f3d)
endif
call nciocl(filename,fid)


end subroutine


subroutine readXF_lilo(FileName)

character(*) :: FileName
integer :: k


!Read XF
call nciopn(filename,fid)
call nciorv(filename,fid,"mld",dpmixl)
call nciorv(filename,fid,"den",den)
call nciorv(filename,fid,"thk",dpin)
call nciocl(filename,fid)
end subroutine

subroutine writeXA_lilo(FileName)
character(*) :: FileName

call nciopn(FileName,fid,'w')
call nciowv(FileName,fid,"thk",dpout)
!call nciowv(FileName,fid,"ssh",cv)
call nciocl(FileName,fid)

end subroutine


subroutine writeXA_ssh(FileName)
character(*) :: FileName

call nciopn(FileName,fid,'w')
call nciowv(FileName,fid,"ssh",cv)
call nciocl(FileName,fid)

end subroutine


subroutine readXF_sst(FileName)

character(*)      :: FileName
integer :: k

!Read XF
call nciopn(filename,fid)
call nciorv(filename,fid,"tem",fv,[1,1,1],[nx,ny,1])
call nciocl(filename,fid)
end subroutine

subroutine writeXA_sst(FileName)

character(*) :: FileName
integer :: k

call nciopn(FileName,fid,'w')
call nciowv(FileName,fid,"tem",cv,[1,1,1],[nx,ny,1])
call nciocl(FileName,fid)
end subroutine

subroutine writeXA(FileName,var)

character(*)             :: var
character(*)             :: FileName
integer :: k


!Read XF

call nciopn(filename,fid,'w')
if(var=="ssh") then
 call nciowv(filename,fid,"ssh",cv)
else if(var=="tem") then
 call nciowv(filename,fid,"tem",a3d)
else if(var=="sal") then
 call nciowv(filename,fid,"sal",a3d)
else if(var=="thk" .or. var=="pin") then
call nciowv(filename,fid,"thk",a3d)
else if(var=="uvl") then
 call nciowv(filename,fid,"uvl",a3d)
else if(var=="vvl") then
 call nciowv(filename,fid,"vvl",a3d)
endif
call nciocl(filename,fid)


end subroutine




END MODULE mstate
