program xcargo

use mkinds
use mdates
use mncio
use mobs

implicit none

integer(i4)                :: ntot
integer(i4)                :: mxlvl
character(8)               :: cdtg

character(:),allocatable  :: argoFile
character(:),allocatable  :: atlFile
character(:),allocatable  :: pacFile
character(:),allocatable  :: indFile
character(:),allocatable  :: rfile

integer(i4)               :: nprof
integer(i4)               :: nlvl
integer(i4)               :: nvalid
integer(i4)               :: fcount
integer(i4)               :: vcount


real(r4),allocatable      :: plon(:)
real(r4),allocatable      :: plat(:)

real(r4),allocatable      :: lon(:)
real(r4),allocatable      :: lat(:)

character(:),allocatable  :: cpres_qc
character(:),allocatable  :: ctemp_qc
character(:),allocatable  :: csaln_qc
character(:),allocatable  :: cjuld_qc
character(:),allocatable  :: cpos_qc
character(:),allocatable  :: cdata_mode

integer(i4),allocatable   :: pres_qc(:,:)
integer(i4),allocatable   :: temp_qc(:,:)
integer(i4),allocatable   :: saln_qc(:,:)
integer(i4),allocatable   :: juld_qc(:)
integer(i4),allocatable   :: pos_qc(:)
integer(i4),allocatable   :: data_mode(:)

real(r4),allocatable      :: ppres(:,:)
real(r4),allocatable      :: ptemp(:,:)
real(r4),allocatable      :: psaln(:,:)
real(r4),allocatable      :: pres(:,:)
real(r4),allocatable      :: temp(:,:)
real(r4),allocatable      :: saln(:,:)

real(r4),allocatable      :: pres1d(:)
real(r4),allocatable      :: temp1d(:)
real(r4),allocatable      :: saln1d(:)
real(r4),allocatable      :: pres1d_qc(:)
real(r4),allocatable      :: temp1d_qc(:)
real(r4),allocatable      :: saln1d_qc(:)
real(r8),allocatable      :: juld(:)
real(r8),allocatable      :: pjuld(:)
real(r4)                  :: date_offset
real(r4)                  :: t_fill_value
real(r4)                  :: s_fill_value
real(r4)                  :: p_fill_value
character(cl)             :: argoFileNames(3)
integer(i4)               :: nargoFiles
integer(i4)               :: i,ii,j

logical(bl)               :: lexist
logical(bl)               :: lrexist
logical(bl)               :: laexist
logical(bl)               :: lpexist
logical(bl)               :: liexist
logical(bl)               :: dt_argo
logical(bl)               :: rt_argo
integer(i4)               :: spresent
character(:),allocatable  :: FileName
real(r4),parameter        :: pr_spval=99999.


call read_obs_location()

!date_offset=ndays(01,01,1950,12,31,1900)
nargoFiles=0
call get_command_argument(1,cdtg)


atlFile=trim(argo_profiles_location)//"/atl/"//cdtg(1:8)//"_prof.nc"
pacFile=trim(argo_profiles_location)//"/pac/"//cdtg(1:8)//"_prof.nc"
indFile=trim(argo_profiles_location)//"/ind/"//cdtg(1:8)//"_prof.nc"
rFile=trim(argo_profiles_location)//"/nrt/"//"R"//cdtg(1:8)//"_prof.nc"



! firxt try delayed time files

INQUIRE(FILE=atlFile, EXIST=laexist)
INQUIRE(FILE=pacFile, EXIST=lpexist)
INQUIRE(FILE=indFile, EXIST=liexist)
INQUIRE(FILE=rFile, EXIST=lrexist)

if(laexist) then
        nargoFiles=nargoFiles+1
        argoFileNames(nargoFiles)=atlFile
endif

if(lpexist) then
        nargoFiles=nargoFiles+1
        argoFileNames(nargoFiles)=pacFile
endif 

if(liexist) then
         nargoFiles=nargoFiles+1
         argoFileNames(nargoFiles)=indFile
endif   




dt_argo = laexist .or. lpexist .or. liexist
rt_argo = lrexist !.and. (.not. dt_argo)

if (dt_argo ) then
        !write(*,*) "....delayed time files available...."
        write(*,*) "....will use the foll delayed files.... "

        do i=1,nargoFiles
        write(*,*) "...."//trim(argoFileNames(i))
        enddo

else if (rt_argo) then
        !write(*,*) "....delayed time files not available but real-time file present...."
        write(*,*) "....will use the foll NRT files...."
        nargofiles=1
        argoFileNames(1)=rFile
        write(*,*) "...."//trim(argoFileNames(1))
else
        write(*,*) "....no argo files...."
        stop
endif


ntot=0
mxlvl=0
do ii=1,nargoFiles
 argoFile=argoFilenames(ii)
call nciopn(argoFile,ncid)
call ncioin(argoFile,ncid,"N_PROF",nprof)
call ncioin(argoFile,ncid,"N_LEVELS",nlvl)
mxlvl=max(mxlvl,nlvl)
ntot=ntot+nprof
enddo


allocate(lon(ntot))
allocate(lat(ntot))
allocate(juld(ntot))
allocate(juld_qc(ntot))
allocate(data_mode(ntot))
allocate(pos_qc(ntot))
allocate(pres(mxlvl,ntot))
allocate(pres_qc(mxlvl,ntot))
allocate(temp(mxlvl,ntot))
allocate(temp_qc(mxlvl,ntot))
allocate(saln(mxlvl,ntot))
allocate(saln_qc(mxlvl,ntot))

pres=pr_spval
saln=pr_spval
temp=pr_spval





fcount=0
do ii=1,nargoFiles
 argoFile=argoFilenames(ii)
 if(allocated(cpres_qc)) deallocate(cpres_qc)
 if(allocated(ctemp_qc)) deallocate(ctemp_qc)
 if(allocated(csaln_qc)) deallocate(csaln_qc)
 if(allocated(cjuld_qc)) deallocate(cjuld_qc)
 if(allocated(cpos_qc))  deallocate(cpos_qc)
 if(allocated(cdata_mode)) deallocate(cdata_mode)
 if(allocated(pjuld)) deallocate(pjuld)
 if(allocated(plon)) deallocate(plon)
 if(allocated(plat)) deallocate(plat)
 if(allocated(ppres)) deallocate(ppres)
 if(allocated(ptemp)) deallocate(ptemp)
 if(allocated(psaln)) deallocate(psaln)

          call nciopn(argoFile,ncid)
          call ncioin(argoFile,ncid,"N_PROF",nprof)
          call ncioin(argoFile,ncid,"N_LEVELS",nlvl)
          
          allocate(pjuld(nprof))
          allocate(plon(nprof))
          allocate(plat(nprof))
          allocate(ppres(nlvl,1))
          allocate(ptemp(nlvl,1))
          allocate(psaln(nlvl,1))

          allocate(character(len=nprof) :: cjuld_qc)
          allocate(character(len=nprof) :: cpos_qc)
          allocate(character(len=nprof) :: cdata_mode)
          allocate(character(len=nlvl) :: cpres_qc)
          allocate(character(len=nlvl) :: ctemp_qc)
          allocate(character(len=nlvl) :: csaln_qc)

          call nciorv(argoFile,ncid,"LONGITUDE",plon)
          call nciorv(argoFile,ncid,"LATITUDE",plat)
          call nciorv(argoFile,ncid,"JULD",pjuld)
          call nciorv(argoFile,ncid,"JULD_QC",cjuld_qc)
          call nciorv(argoFile,ncid,"POSITION_QC",cpos_qc)
          call nciorv(argoFile,ncid,"DATA_MODE",cdata_mode)

          do i=1,nprof
          fcount=fcount+1
            if(cdata_mode(i:i)=="A" .or. cdata_mode(i:i)=="D") then
             call nciorv(argoFile,ncid,"PRES_ADJUSTED",ppres,[1,i],[nlvl,1])
             call nciorv(argoFile,ncid,"TEMP_ADJUSTED",ptemp,[1,i],[nlvl,1])
             call nciorv(argoFile,ncid,"PSAL_ADJUSTED",psaln,[1,i],[nlvl,1])
             call nciorv(argoFile,ncid,"PRES_ADJUSTED_QC",cpres_qc,[1,i],[nlvl,1])
             call nciorv(argoFile,ncid,"TEMP_ADJUSTED_QC",ctemp_qc,[1,i],[nlvl,1])
             call nciorv(argoFile,ncid,"PSAL_ADJUSTED_QC",csaln_qc,[1,i],[nlvl,1])
          else if(cdata_mode(i:i)=="R") then
             call nciorv(argoFile,ncid,"PRES",ppres,[1,i],[nlvl,1])
             call nciorv(argoFile,ncid,"TEMP",ptemp,[1,i],[nlvl,1])
             call nciorv(argoFile,ncid,"PSAL",psaln,[1,i],[nlvl,1])
             call nciorv(argoFile,ncid,"PRES_QC",cpres_qc,[1,i],[nlvl,1])
             call nciorv(argoFile,ncid,"TEMP_QC",ctemp_qc,[1,i],[nlvl,1])
             call nciorv(argoFile,ncid,"PSAL_QC",csaln_qc,[1,i],[nlvl,1])
          endif
              
             read(cjuld_qc(i:i),*) juld_qc(fcount)
             read(cpos_qc(i:i),*) pos_qc(fcount)
             if(cdata_mode(i:i)=='R') then
                     data_mode(fcount)=1
             else if(cdata_mode(i:i)=='A') then
                     data_mode(fcount)=2
             else if(cdata_mode(i:i)=='D') then
                     data_mode(fcount)=3
             endif

             lon(fcount)=plon(i)
             lat(fcount)=plat(i)
             juld(fcount)=pjuld(i)

             do j=1,nlvl
              if(cpres_qc(j:j)=="") then
                pres_qc(j,fcount)=0
              else
                read(cpres_qc(j:j),*) pres_qc(j,fcount)
              endif
             if(ctemp_qc(j:j)=="") then
                     temp_qc(j,fcount) =0
             else
                      read(ctemp_qc(j:j),*) temp_qc(j,fcount)
              endif

              if(csaln_qc(j:j)=="") then
                     saln_qc(j,fcount)=0
             else 
              read(csaln_qc(j:j),*) saln_qc(j,fcount)
              endif
             
             
              pres(j,fcount)=ppres(j,1)
              temp(j,fcount)=ptemp(j,1)
              saln(j,fcount)=psaln(j,1)
            enddo
          enddo  

         enddo

    filename=trim(argo_profiles_location)//"/cargo/cargo_l2_"//cdtg//".nc"

    call nciocf(filename,fid) 
    vname="N_LEVELS"
    vtype=NF90_INT
    vdim1d(1)=1
    call nciodd(filename,fid,vname,mxlvl)
!    call nciocv(filename,fid,vname,vtype,vdim1d)

    vname="N_PROF"
    vtype=NF90_INT
    vdim1d(1)=2
    call nciodd(filename,fid,vname,ntot)
!    call nciocv(filename,fid,vname,vtype,vdim1d)

    vname="LONGITUDE"
    vtype=NF90_float
    vdim1d(1)=2
    call nciocv(filename,fid,vname,vtype,vdim1d)
    call nciowa(filename,fid,vname,'_FillValue',pr_spval)

    vname="LATITUDE"
    vtype=NF90_float
    vdim1d(1)=2
    call nciocv(filename,fid,vname,vtype,vdim1d)
    call nciowa(filename,fid,vname,'_FillValue',pr_spval)

    vname="JULD"
    vtype=NF90_double
    vdim1d(1)=2
    call nciocv(filename,fid,vname,vtype,vdim1d)

    vname="JULD_QC"
    vtype=NF90_INT
    vdim1d(1)=2
    call nciocv(filename,fid,vname,vtype,vdim1d)
    
    vname="POSITION_QC"
    vtype=NF90_INT
    vdim1d(1)=2
    call nciocv(filename,fid,vname,vtype,vdim1d)

    vname="DATA_MODE"
    vtype=NF90_INT
    vdim1d(1)=2
    call nciocv(filename,fid,vname,vtype,vdim1d)

    vname="PRES"
    vtype=NF90_FLOAT
    vdim2d=(/1,2/)
    call nciocv(filename,fid,vname,vtype,vdim2d)
    call nciowa(filename,fid,vname,'_FillValue',pr_spval)

    vname="PRES_QC"
    vtype=NF90_INT
    vdim2d=(/1,2/)
    call nciocv(filename,fid,vname,vtype,vdim2d)

    vname="TEMP"
    vtype=NF90_FLOAT
    vdim2d=(/1,2/)
    call nciocv(filename,fid,vname,vtype,vdim2d)
    call nciowa(filename,fid,vname,'_FillValue',pr_spval)


    vname="TEMP_QC"
    vtype=NF90_INT
    vdim2d=(/1,2/)
    call nciocv(filename,fid,vname,vtype,vdim2d)


    vname="PSAL"
    vtype=NF90_FLOAT
    vdim2d=(/1,2/)
    call nciocv(filename,fid,vname,vtype,vdim2d)
    call nciowa(filename,fid,vname,'_FillValue',pr_spval)

    vname="PSAL_QC"
    vtype=NF90_INT
    vdim2d=(/1,2/)
    call nciocv(filename,fid,vname,vtype,vdim2d)

    call ncioed(filename,fid)
    
    call nciowv(filename,fid,"LONGITUDE",lon)
    call nciowv(filename,fid,"LATITUDE",lat)
    call nciowv(filename,fid,"JULD",juld)
    call nciowv(filename,fid,"JULD_QC",juld_qc)
    call nciowv(filename,fid,"POSITION_QC",pos_qc)
    call nciowv(filename,fid,"DATA_MODE",data_mode)
    call nciowv(filename,fid,"PRES",pres)
    call nciowv(filename,fid,"PRES_QC",pres_qc)
    call nciowv(filename,fid,"TEMP",temp)
    call nciowv(filename,fid,"TEMP_QC",temp_qc)
    call nciowv(filename,fid,"PSAL",saln)
    call nciowv(filename,fid,"PSAL_QC",saln_qc)


    call nciocl(filename,fid)

end program


