program xgmrf
USE OMP_LIB
use minit
use mminfo
use mncio
use mgmrf
use mhycom
use mfld
use mavect
use mlilo
use msproject
use mpost
use mc2r
use mprep


implicit none

integer         :: k

! inilization
            call initialize_tsis()
            print*,'xgmrf:TSIS init' !!Alex
            call set_vproject()
            print*,'xgmrf:vproject' !!Alex

! analysis
            call omp_set_num_threads(nl)
            call initInfoPair(nx,ny,nl,3)
            f3(:,:,:,1)=ftem
            f3(:,:,:,2)=fsal
            f3(:,:,:,3)=fpin(:,:,1:nl)
            fathk=fthk
            athk=fthk
            print*,'xgmrf:ftem, fsal' !!Alex

              
            if(l3sla) then
              print*,'l3sla' !!Alex
              var="l3ssh"
              k=1
              cv=0.0;bv=0.0;iv=0.0;ev=0.0;vv=0.0
              fv=fssh
              call getbvev(analysis_date,pfx,var,bv,ev,k)
              print*,'xgmrf:getbvev' !!Alex

              call getvv(var,vv,k)
              print*,'xgmrf:getvv' !!Alex

              call set_bv(var,mdepth,bv,fv,spval)
              print*,'xgmrf:set_bv' !!Alex

              call remove_mn(bv,mdepth,nx,ny,spval,"ssh obs mean")
              where(abs(iv)>1.0) iv=1.0*(iv/(abs(iv)))
              call setInfoMatrix(nx,ny,1,1,msk3d(:,:,1))
              call setInfoVector(nx,ny,1,1,bv,vv)
              call roifPCG(iv,nx,ny,1,1,msk3d(:,:,1))
              call ncfldio("issh.nc",mlon(:,1),mlat(1,:),mlayer,stime(1),iv,"iv","ssh increments","m",nx,ny,1,1)
              sla_inc=iv
              if(hproject==0) then
                call lilo(start,count,mdepth,thref,thbase,dp0k,fthk,fden,fmld,iv,athk)              
              else
                call project_hdp(nx,ny,nl,mdepth,fthk,iv,athk)
              endif        
              call update_pin(athk,fpin,nx,ny,nl)
            endif

            if(l3sst) then
              var="l3sst"
              k=1
              cv=0.0;bv=0.0;iv=0.0;ev=0.0;vv=0.0
              fv=fsst
              call getbvev(analysis_date,pfx,var,bv,ev,k)
              call getvv(var,vv,k)
              call set_bv(var,mdepth,bv,fv,spval)
              !call remove_mn(bv,mdepth,nx,ny,spval,"ssh obs mean")
!              where(abs(iv)>1.0) iv=1.0*(iv/(abs(iv)))
              call setInfoMatrix(nx,ny,1,1,msk3d(:,:,1))
              call setInfoVector(nx,ny,1,1,bv,vv)
              call roifPCG(iv,nx,ny,1,1,msk3d(:,:,1))
              call ncfldio("sst.nc",mlon(:,1),mlat(1,:),mlayer,stime(1),iv,"iv","sst increments","degc",nx,ny,1,1)
              sst_inc=iv   ! increments to be stored.
              asst=fsst+iv ! needed for residuals
              call project_sst(nx,ny,nl,mdepth,iv,f3(:,:,:,1),f3(:,:,:,3),fmld) ! use mld and updated pin
             endif
              !var="l2sss"
              !k=1
              !cv=0.0;bv=0.0;iv=0.0;ev=0.0;vv=0.0
              !fv=fsss
              !call getbvev(analysis_date,pfx,var,bv,ev,k)
              !call getvv(var,vv,k)
              !call set_bv(var,mdepth,bv,fv,spval)
              !call setInfoMatrix(nx,ny,1,1,msk3d(:,:,1))
              !call setInfoVector(nx,ny,1,1,bv,vv)
              !call roifPCG(iv,nx,ny,1,1,msk3d(:,:,1))
              !call ncfldio("sss.nc",mlon(:,1),mlat(1,:),mlayer,stime(1),iv,"iv","sss increments","",nx,ny,1,1)

              ! set fvector here to handle no data case
              f3(:,:,1:nl,3)=fpin(:,:,1:nl) ! updated from ssh
              if(l2profile) then
               print*,'l2profile'!!Alex
               call init_pobs(analysis_date,nobs,pfx)
               ivar=1;b3=0.0;i3=0.0;v3=0.0;e3=0.0
               call pobs2mgrid3(nobs,ivar,ilvl,b3,e3,nvalid)
               call setInfoMatrix(nx,ny,nl,3,msk3d)
               call setInfoVector(nx,ny,nl,3,b3,v3)
               call roifPCG(i3,nx,ny,nl,3,msk3d)
               f3(:,:,:,1)=i3(:,:,:,1)+f3(:,:,:,1) ! set fvector for post
               f3(:,:,:,2)=i3(:,:,:,2)+f3(:,:,:,2)
               fpin(:,:,1:nl)=i3(:,:,1:nl,3)+fpin(:,:,1:nl)
               call update_dp(fpin,athk,mdepth,nx,ny,nl) ! update athk
               call getssh(nx,ny,nl,kapref,pref,thbase,thref,msk3d(:,:,1),f3(:,:,:,2),f3(:,:,:,1),athk,fden-thbase,fpba,fpsikk,fthkk,fmgp,assh)
              endif
              
              !!Alex  call post()



              fthk=athk-fthk
              where(abs(fthk)<onem)fthk=0.0
              ftem=f3(:,:,:,1)-ftem
              fsal=f3(:,:,:,2)-fsal
              fuvl=0.0
              fvvl=0.0

             if(c2r==1) then
              call r2cxi(XAFileName,nx,ny,nl,mlon,mlat,mlayer,mdepth,sla_inc,fuvl,fvvl,fthk,ftem,fsal)
             else
              call writeHYCOMXI(XAFileName,nx,ny,nl,mlon,mlat,mlayer,mdepth,sla_inc,fuvl,fvvl,fthk,ftem,fsal)
             endif

end program xgmrf

