program xsclim
use mkinds
use mconstants
use mncio
use mdates
use mstring
use mobs

implicit none

character(10)            :: analysis_date
character(8)                   :: ymd
real(r4)                       :: wc1,wc2,wc3,wc0
integer(i4)                    :: mc1,mc0,mc2,mc3
integer(i4)                    :: jj,iyyyy,imm,idd,ihh
character(2)                   :: cm0,cm1,cm2,cm3
character(:),allocatable       :: cFloc,cFname,cpfx
integer(i4)                    :: stat
character(:),allocatable       :: f_0,f_1,f_2,f_3,f_out,fstd,fzbot
real(r4),allocatable           :: tmp3d(:,:,:),lon(:),lat(:),depth(:)
real(r4),allocatable           :: temp4(:,:,:,:),saln4(:,:,:,:),zbot(:,:)
real(r4),allocatable           :: temp(:,:,:),saln(:,:,:),tstd(:,:,:),sstd(:,:,:)
integer(i4)                    :: nx,ny,nz
real(r4)                       :: rfill
integer(i4),allocatable        :: mask(:,:,:)
integer(i4)                    :: i,j,k

call get_command_argument(1,analysis_date)
call initialize_obs()


nx=1440
ny=720
nz=60

allocate(lon(nx),lat(ny),depth(nz))
allocate(tmp3d(nx,ny,nz))
allocate(temp4(nx,ny,nz,4),saln4(nx,ny,nz,4))
allocate(saln(nx,ny,nz),sstd(nx,ny,nz))
allocate(temp(nx,ny,nz),tstd(nx,ny,nz))
allocate(zbot(nx,ny))
allocate(mask(nx,ny,nz))


cpfx="tops_woa23v60_m"
cFloc=trim(sclim_data_location)!"/raid/data7/climatology/tops_woa23v60/"
ihh=0
ymd=analysis_date

fzbot=trim(sclim_data_location)//"/tops_woa23_grid.nc"
call nciopn(fzbot,fid)
call nciorv(fzbot,fid,"zbot",zbot)
call nciorv(fzbot,fid,"mask",mask)
call nciocl(fzbot,fid)


call c2iymd(ymd,iyyyy,imm,idd,ihh)
jj=ymd2ydn(iyyyy,imm,idd)
call cwgts(jj,mc0,mc1,mc2,mc3,wc0,wc1,wc2,wc3)
call int2str(mc0,cm0,'(i2.2)',stat)
call int2str(mc1,cm1,'(i2.2)',stat)
call int2str(mc2,cm2,'(i2.2)',stat)
call int2str(mc3,cm3,'(i2.2)',stat)

fstd=trim(cFloc)//"tops_woa23v60_std.nc"
f_0=trim(cFloc)//trim(cpfx)//cm0//".nc"
f_1=trim(cFloc)//trim(cpfx)//cm1//".nc"
f_2=trim(cFloc)//trim(cpfx)//cm2//".nc"
f_3=trim(cFloc)//trim(cpfx)//cm3//".nc"

call nciopn(f_0,fid)
call nciorv(f_0,fid,"lon",lon)
call nciorv(f_0,fid,"lat",lat)
call nciorv(f_0,fid,"depth",depth)
call nciorv(f_0,fid,"ptemp",tmp3d)
temp4(:,:,:,1)=tmp3d
call nciorv(f_0,fid,"saln",tmp3d)
saln4(:,:,:,1)=tmp3d
call nciocl(f_0,fid)

call nciopn(f_1,fid)
call nciorv(f_1,fid,"ptemp",tmp3d)
temp4(:,:,:,2)=tmp3d
call nciorv(f_1,fid,"saln",tmp3d)
saln4(:,:,:,2)=tmp3d
call nciocl(f_1,fid)

call nciopn(f_2,fid)
call nciorv(f_2,fid,"ptemp",tmp3d)
temp4(:,:,:,3)=tmp3d
call nciorv(f_2,fid,"saln",tmp3d)
saln4(:,:,:,3)=tmp3d
call nciocl(f_2,fid)

call nciopn(f_3,fid)
call nciorv(f_3,fid,"ptemp",tmp3d)
temp4(:,:,:,4)=tmp3d
call nciorv(f_3,fid,"saln",tmp3d)
saln4(:,:,:,4)=tmp3d
call nciocl(f_3,fid)

where(mask==1)
temp=temp4(:,:,:,1)*wc0+temp4(:,:,:,2)*wc1+temp4(:,:,:,3)*wc2+temp4(:,:,:,3)*wc3
saln=saln4(:,:,:,1)*wc0+saln4(:,:,:,2)*wc1+saln4(:,:,:,3)*wc2+saln4(:,:,:,3)*wc3
else where
temp=spval
saln=spval
end where

call nciopn(fstd,fid)
call nciorv(fstd,fid,"tstd",tstd)
call nciorv(fstd,fid,"sstd",sstd)
call nciocl(fstd,fid)

!where(tstd>=0.1*spval) tstd=0.1
!where(sstd>=0.1*spval) tstd=0.05        






f_out="sclim_"//ymd//"00.nc"

call nciocf(f_out,fid)
!create dimension and coordinate variable 1
vname="lon"
vtype=NF90_FLOAT
vdim1d(1)=1
call nciodd(f_out,fid,vname,nx)
call nciocv(f_out,fid,vname,vtype,vdim1d)
call nciowa(f_out,fid,vname,'long_name','Longitude')
call nciowa(f_out,fid,vname,'standard_name','Longitude')
call nciowa(f_out,fid,vname,'units','degrees_east')

!create dimension and coordinate variable 2

vname="lat"
vtype=NF90_Float
vdim1d(1)=2
call nciodd(f_out,fid,vname,ny)
call nciocv(f_out,fid,vname,vtype,vdim1d)
call nciowa(f_out,fid,vname,'long_name','Latitude')
call nciowa(f_out,fid,vname,'standard_name','Latitude')
call nciowa(f_out,fid,vname,'units','degrees_north')

!create dimension and coordinate variable 3

vname="depth"
vtype=NF90_Float
vdim1d(1)=3
call nciodd(f_out,fid,vname,nz)
call nciocv(f_out,fid,vname,vtype,vdim1d)
call nciowa(f_out,fid,vname,'standard_name','depth')
call nciowa(f_out,fid,vname,'units','m')

!create data variable 1
vname="ptemp"
vtype=NF90_Float
vdim3d=(/1,2,3/)
call nciocv(f_out,fid,vname,vtype,vdim3d)
call nciowa(f_out,fid,vname,'long_name','seawater_potential_temperature')
call nciowa(f_out,fid,vname,'units','degC')
call nciowa(f_out,fid,vname,'_FillValue',spval)

!create data variable 2
vname="tstd"
vtype=NF90_Float
vdim3d=(/1,2,3/)
call nciocv(f_out,fid,vname,vtype,vdim3d)
call nciowa(f_out,fid,vname,'long_name','seawater_potential_temperature_std_dev')
call nciowa(f_out,fid,vname,'units','deg c')
call nciowa(f_out,fid,vname,'_FillValue',spval)


!create data variable 1
vname="saln"
vtype=NF90_Float
vdim3d=(/1,2,3/)
call nciocv(f_out,fid,vname,vtype,vdim3d)
call nciowa(f_out,fid,vname,'long_name','seawater_salinity')
call nciowa(f_out,fid,vname,'units','')
call nciowa(f_out,fid,vname,'_FillValue',spval)

!create data variable 2
vname="sstd"
vtype=NF90_Float
vdim3d=(/1,2,3/)
call nciocv(f_out,fid,vname,vtype,vdim3d)
call nciowa(f_out,fid,vname,'long_name','seawater_salinity_std_dev')
call nciowa(f_out,fid,vname,'units','')
call nciowa(f_out,fid,vname,'_FillValue',spval)


!create data variable 2
vname="zbot"
vtype=NF90_Float
vdim2d=(/1,2/)
call nciocv(f_out,fid,vname,vtype,vdim2d)
call nciowa(f_out,fid,vname,'long_name','woa_bottom_depth')
call nciowa(f_out,fid,vname,'units','m')
call nciowa(f_out,fid,vname,'_FillValue',spval)


call ncioed(f_out,fid)

! write data into variables
call nciowv(f_out,fid,"lon",lon)
call nciowv(f_out,fid,"lat",lat)
call nciowv(f_out,fid,"depth",depth)
call nciowv(f_out,fid,"ptemp",temp)
call nciowv(f_out,fid,"saln",saln)
call nciowv(f_out,fid,"tstd",tstd)
call nciowv(f_out,fid,"sstd",sstd)
call nciowv(f_out,fid,"zbot",zbot)


! close file
call nciocl(f_out,fid)

end program        
