program xwhgobs
use mkinds
use mconstants
use mncio
use mglobals
use mcsv
use mobs
use mgrid
use mminfo
use mtsclim
use marmor



implicit none

character(:),allocatable   :: gFile,whgFile,wobsFile
integer(i4),allocatable    :: indx(:,:,:),sindx(:,:)
integer(i4)                :: np,np_saln,np_temp
real(r4),allocatable       :: plon(:)
real(r4),allocatable       :: plat(:)
real(r4),allocatable       :: ptime(:)
real(r4),allocatable       :: temp(:,:)            
real(r4),allocatable       :: saln(:,:)
real(r4),allocatable       :: a_plon(:)
real(r4),allocatable       :: a_plat(:)
real(r4),allocatable       :: a_ptime(:)
real(r4),allocatable       :: a_temp(:,:)
real(r4),allocatable       :: a_saln(:,:)
real(r4),allocatable       :: a_ctemp(:,:)
real(r4),allocatable       :: a_csaln(:,:)
real(r4),allocatable       :: a_ctstd(:,:)
real(r4),allocatable       :: a_csstd(:,:)
real(r4),allocatable       :: a_dcsaln(:,:)
real(r4),allocatable       :: a_dctemp(:,:)
integer(i4),allocatable    :: a_it(:,:)
integer(i4),allocatable    :: a_is(:,:)
integer(i4),allocatable    :: a_valid(:,:)
integer(i4),allocatable    :: a_typ(:)
integer(i4),allocatable    :: prof_num(:)



integer(i4),parameter      :: mx_prf=1000
integer(i4)                :: i,j,k,ii,jj
integer(i4)                :: iflag


!initialize analysis grid first for spmd processing
call initialize_analysis_grid()
call set_analysis_date()
call initialize_obs()
call init_sclim_grid(sclim_data_location)
nz=cnz


allocate(plon(mx_prf))
allocate(plat(mx_prf))
allocate(ptime(mx_prf))
allocate(temp(mx_prf,nz))
allocate(saln(mx_prf,nz))
allocate(sindx(nx,ny))



whgFile=trim(tops_master_data_location)//"/"//analysis_date(1:8)//"/last72h.salinity.txt"
call read_last72(whgFile,plon,plat,cdpth,saln,mx_prf,nz,np_saln)
whgFile=trim(tops_master_data_location)//"/"//analysis_date(1:8)//"/last72h.temperature.txt"
call read_last72(whgFile,plon,plat,cdpth,temp,mx_prf,nz,np_temp)
print *, whgFile
print *, np_saln,np_temp
if(np_saln==np_temp) then
np=np_saln
print *, np_saln,np_temp
allocate(prof_num(np))
allocate(a_it(np,nz))
allocate(a_is(np,nz))
allocate(a_valid(np,3))
allocate(a_typ(np))
allocate(a_plon(np))
allocate(a_plat(np))
allocate(a_ptime(np))
allocate(a_temp(np,nz))
allocate(a_saln(np,nz))
allocate(a_ctemp(np,nz))
allocate(a_csaln(np,nz))
allocate(a_ctstd(np,nz))
allocate(a_csstd(np,nz))
allocate(a_dctemp(np,nz))
allocate(a_dcsaln(np,nz))

sindx=0
do j=1,np
 ii=nint(ridx(mlon(:,1),plon(j)))
 jj=nint(ridx(mlat(1,:),plat(j)))
 sindx(ii,jj)=1
 a_plon(j)=plon(j)
 a_plat(j)=plat(j)
 a_ptime(j)=44952.0
 a_valid(j,:)=1
 a_typ(j)=1
 prof_num(j)=j

 do k=1,nz
 a_temp(j,k)=temp(j,k)
 a_saln(j,k)=saln(j,k)
 if(a_temp(j,k)>-99.0) a_it(j,k)=1
 if(a_saln(j,k)>-99.0) a_is(j,k)=1
!  write(*,'(I5,5F12.2)') j,plon(j),plat(j),cdpth(k),a_temp(j,k),a_saln(j,k) 
enddo



enddo 
endif
print *,sum(sindx)

call read_sclim(analysis_date,iflag)
    if(iflag==0) then
     call sclim_mpts(analysis_date,plon(1:np),plat(1:np),a_ctemp,a_csaln,a_ctstd,a_csstd,np,nz)
    endif


!    do i=1,np
!         write(*,*) "************"
!         do k=1,nz
!         write(*,'(I5,7F12.2)') i,cdpth(k),temp(i,k),a_ctemp(i,k),a_ctstd(i,k),saln(i,k),a_csaln(i,k),a_csstd(i,k)
!         enddo

!    enddo

!stop

    call armor_build_lookup(dclim_data_location,analysis_date)
    call init_armor(dclim_data_location,analysis_date,iflag)
    if(iflag==0) then
      call get_dclim_profiles(analysis_date,np,plon,plat,nz,cdpth,a_dctemp,a_dcsaln)
    endif
!        do i=1,np
!         write(*,*) "************"
!         do k=1,nz
!         write(*,'(I5,9F12.2)') i,cdpth(k),temp(i,k),a_dctemp(i,k),a_ctemp(i,k),a_ctstd(i,k),saln(i,k),a_dcsaln(i,k),a_csaln(i,k),a_csstd(i,k)
!         enddo

!    enddo
!stop

wobsFile=trim(cobs_location)//analysis_date(1:4)//"/tsis_"//trim(cobs_pfx)//"_"//analysis_date//".nc"


! write out wobs file

call write_wobs_file_skel(wobsFile,np,nz,prof_num,cdpth,a_plon,a_plat,a_ptime,&
                            a_temp,a_saln,a_ctemp,a_csaln,a_dctemp,a_dcsaln,a_ctstd,a_csstd,a_it,a_is,a_valid,a_typ)
end program xwhgobs 

subroutine read_last72(whgFile,plon,plat,cdpth,pvar,mx_prf,nz,np)
use mkinds
use mconstants
use mlinint
use msplint
use mcsv
use msearch


implicit none

character(*)               :: whgFile
integer(i4)                :: mx_prf
integer(i4)                :: nz
real(r4)                   :: plon(mx_prf)
real(r4)                   :: plat(mx_prf)
real(r4)                   :: pvar(mx_prf,nz)
real(r4)                   :: cdpth(nz)
integer(i4),intent(inout)  :: np



integer(i4)                :: j,k,i
character(25)              :: xstr
character(25),allocatable  :: xid(:)
character(20),allocatable  :: platform_type(:)
character(20),allocatable  :: id(:)
character(20)              :: typ,idd
character(20),allocatable  :: cdate(:)
character(20),allocatable  :: ctime(:)
real(r4),allocatable       :: lon(:)
real(r4),allocatable       :: lat(:)
real(r4),allocatable       :: depth(:)
real(r4),allocatable       :: val(:)
integer(i4),allocatable    :: idpth(:)
character(20),allocatable  :: bb(:)
character(20),allocatable  :: units(:)
character(cl)              :: header
character(:),allocatable   :: stzFile
real(r4),allocatable       :: level(:)
integer(i4)                :: pmx,nlines
integer(i4),allocatable    :: lst(:),lend(:)
real(r4)                   :: v1d(5000)
real(r4)                   :: d1d(5000)
real(r4)                   :: iv(60)
integer(i4)                :: kmx,kcmx



nlines=Fnlines(whgFile)
nlines=nlines-1
allocate(xid(nlines))
allocate(platform_type(nlines))
allocate(id(nlines))
allocate(cdate(nlines))
allocate(ctime(nlines))
allocate(lon(nlines))
allocate(lat(nlines))
allocate(depth(nlines))
allocate(val(nlines))
allocate(bb(nlines))
allocate(units(nlines))
allocate(idpth(nlines))

xstr="xxxxxxxxxxxxxxxxxxxxxxxxx"
!platform_type,id,t_utc,lon,lat,depth_m,u,v,uom
!float,ARGO-4902351,2024-01-18 09:21:52,-90.40297,23.40424,15,24.8255479919161,,degree_Celsius
open(unit=20,file=whgFile,status="unknown")
read(20,*)

do k=1,nlines
read(20,*) platform_type(K),id(k),cdate(k),ctime(k),lon(k),lat(k),depth(k),val(k),units(k)
typ=platform_type(K)
idd=id(k)
xstr(1:8)=typ(1:8)
xstr(9:24)=idd(1:15)
xid(k)=xstr
enddo
close(20)

np=0
do k=2,nlines
if(depth(k)<depth(k-1)) then
 !write(*,'(a8,2x,a20,2x,a10,2x,a10,2x,4F12.2,2x,a20)') platform_type(k-1),id(k-1),cdate(k-1),ctime(k-1),lon(k-1),lat(k-1),depth(k-1),val(k-1),units(k-1)
 np=np+1
! print *, k,xid(k)
endif
enddo


allocate(lst(np))
allocate(lend(np))
np=0
lst(1)=1
do k=2,nlines
if(depth(k)<depth(k-1)) then
 !write(*,'(a8,2x,a20,2x,a10,2x,a10,2x,4F12.2,2x,a20)') platform_type(k-1),id(k-1),cdate(k-1),ctime(k-1),lon(k-1),lat(k-1),depth(k-1),val(k-1),units(k-1)
 np=np+1
lend(np)=k-1
endif
enddo

lst(1)=1
plon(1)=lon(1)
plat(1)=lat(1)

do k=2,np
lst(k)=lend(k-1)+1
plon(k)=lon(lst(k))
plat(k)=lat(lst(k))
enddo



do k=1,np
i=0
do j=lst(k),lend(k)
i=i+1
!print *, k,lon(j),lat(j),depth(j),val(j)
d1d(i)=depth(j)
v1d(i)=val(j)
enddo
kmx=i
d1d(1)=0.0
pvar(k,:)=-99.0
iv=0.0



call linint(kmx,d1d(1:kmx),v1d(1:kmx),nz,cdpth,iv)
pvar(k,:)=iv




enddo
end subroutine


subroutine write_wobs_file_skel(filename,ncount,nzl,prof_num,zlevels,plon,plat,ptime,&
                            temp,saln,sctemp,scsaln,dctemp,dcsaln,ctstd,csstd,it,is,pvalid,ityp)

  use mkinds
  use mncio
  use mglobals               
                  
  implicit none

  character(*)             :: filename
  integer(i4)               :: ncount,nsla,nzl,nft
  integer(i4)               :: prof_num(ncount)
  real(r4)                  :: zlevels(nzl)
  real(r4)                  :: plon(ncount),plat(ncount),ptime(ncount)
  real(r4)                  :: temp(ncount,nzl),saln(ncount,nzl)
  real(r4)                  :: sctemp(ncount,nzl),scsaln(ncount,nzl)
  real(r4)                  :: dctemp(ncount,nzl),dcsaln(ncount,nzl)
  real(r4)                  :: ctstd(ncount,nzl),csstd(ncount,nzl)
  integer(i4)               :: it(ncount,nzl),is(ncount,nzl),ityp(ncount)
  integer(i4)               :: qctype(3)
  integer(i4)               :: pvalid(ncount,3)
  real(r4),parameter        :: pr_spval=-99.0
  integer(i4)               :: i

    qctype=[1,2,3]

  call nciocf(filename,fid)
    
  vname="nprof"
  vtype=NF90_INT
  vdim1d(1)=1
  call nciodd(filename,fid,vname,ncount)
  call nciocv(filename,fid,vname,vtype,vdim1d)
  call nciowa(filename,fid,vname,'long_name','profile_number')
  call nciowa(filename,fid,vname,'standard_name','profile_number')

  vname="depth"
  vtype=NF90_Float
  vdim1d(1)=2
  call nciodd(filename,fid,vname,nzl)
  call nciocv(filename,fid,vname,vtype,vdim1d)
  call nciowa(filename,fid,vname,'long_name','pressure')
  call nciowa(filename,fid,vname,'standard_name','pressure')
  call nciowa(filename,fid,vname,'units','decibars')

  vname="nobsgrp"
  vtype=NF90_INT
  vdim1d(1)=3
  call nciodd(filename,fid,vname,nobsgrp)
  call nciocv(filename,fid,vname,vtype,vdim1d)
  call nciowa(filename,fid,vname,'long_name','no_observation_groups')

  !create data variable 10
  vname="obsgrp"
  vtype=NF90_INT
  vdim1d=(/3/)
  call nciocv(filename,fid,vname,vtype,vdim1d)
  call nciowa(filename,fid,vname,'standard_name','obs_groups_present')

  !create data variable 1
  vname="plon"
  vtype=NF90_Float
  vdim1d=(/1/)
  call nciocv(filename,fid,vname,vtype,vdim1d)
  call nciowa(filename,fid,vname,'long_name','profile_longitude')

  vname="plat"
  vtype=NF90_Float
  vdim1d=(/1/)
  call nciocv(filename,fid,vname,vtype,vdim1d)
  call nciowa(filename,fid,vname,'long_name','profile_latitude')

  vname="ptime"
  vtype=NF90_Float
  vdim1d=(/1/)
  call nciocv(filename,fid,vname,vtype,vdim1d)
  call nciowa(filename,fid,vname,'long_name','time')
  call nciowa(filename,fid,vname,'standard_name','time')
  call nciowa(filename,fid,vname,'units','days since 1900-12-31')
  call nciowa(filename,fid,vname,'_FillValue',pr_spval)

  !create data variable 2
  vname="temp"
  vtype=NF90_Float
  vdim2d=(/1,2/)
  call nciocv(filename,fid,vname,vtype,vdim2d)
  call nciowa(filename,fid,vname,'long_name','Potential Temperature')
  call nciowa(filename,fid,vname,'standard_name','Potential Temperature')
  call nciowa(filename,fid,vname,'units','degC')
  call nciowa(filename,fid,vname,'_FillValue',pr_spval)

!create data variable 3
  vname="saln"
  vtype=NF90_Float
  vdim2d=(/1,2/)
  call nciocv(filename,fid,vname,vtype,vdim2d)
  call nciowa(filename,fid,vname,'long_name','Salinity')
  call nciowa(filename,fid,vname,'standard_name','Salinity')
  call nciowa(filename,fid,vname,'units','psu')
  call nciowa(filename,fid,vname,'_FillValue',pr_spval)

  !create data variable 4
  vname="sctemp"
  vtype=NF90_Float
  vdim2d=(/1,2/)
  call nciocv(filename,fid,vname,vtype,vdim2d)
  call nciowa(filename,fid,vname,'long_name','WOA23_static_climatological_seawater_potential_temperature')
  call nciowa(filename,fid,vname,'standard_name','WOA23_static_climatological_seawater_ potential temperature')
  call nciowa(filename,fid,vname,'units','degC')
  call nciowa(filename,fid,vname,'_FillValue',pr_spval)

!create data variable 3
  vname="scsaln"
  vtype=NF90_Float
  vdim2d=(/1,2/)
  call nciocv(filename,fid,vname,vtype,vdim2d)
  call nciowa(filename,fid,vname,'long_name','WOA23_static_climatological_seawater_salinity')
  call nciowa(filename,fid,vname,'standard_name','WOA23_static_climatological_seawater_salinity')
  call nciowa(filename,fid,vname,'units','')
  call nciowa(filename,fid,vname,'_FillValue',pr_spval)

!create data variable 4
  vname="dctemp"
  vtype=NF90_Float
  vdim2d=(/1,2/)
  call nciocv(filename,fid,vname,vtype,vdim2d)
  call nciowa(filename,fid,vname,'long_name','dynamic_climatological_seawater_potential_temperature')
  call nciowa(filename,fid,vname,'standard_name','dynamic_climatological_seawater_ potential temperature')
  call nciowa(filename,fid,vname,'units','degC')
  call nciowa(filename,fid,vname,'_FillValue',pr_spval)

!create data variable 3
  vname="dcsaln"
  vtype=NF90_Float
  vdim2d=(/1,2/)
  call nciocv(filename,fid,vname,vtype,vdim2d)
  call nciowa(filename,fid,vname,'long_name','dynamic_climatological_seawater_salinity')
  call nciowa(filename,fid,vname,'standard_name','dynamic_climatological_seawater_salinity')
  call nciowa(filename,fid,vname,'units','')
  call nciowa(filename,fid,vname,'_FillValue',pr_spval)
vname="ctstd"
  vtype=NF90_Float
  vdim2d=(/1,2/)
  call nciocv(filename,fid,vname,vtype,vdim2d)
  call nciowa(filename,fid,vname,'long_name','WOA23_climatological_seawater_potential_temperature_std_dev')
  call nciowa(filename,fid,vname,'standard_name','WOA23_climatological_seawater_potential_temperature_std_dev')
  call nciowa(filename,fid,vname,'units','degC')
  call nciowa(filename,fid,vname,'_FillValue',pr_spval)

  vname="csstd"
  vtype=NF90_Float
  vdim2d=(/1,2/)
  call nciocv(filename,fid,vname,vtype,vdim2d)
  call nciowa(filename,fid,vname,'long_name','WOA23_climatological_seawater_potential_salinity_std_dev')
  call nciowa(filename,fid,vname,'standard_name','WOA23_climatological_seawater_potential_salinity_std_dev')
  call nciowa(filename,fid,vname,'units','')
  call nciowa(filename,fid,vname,'_FillValue',pr_spval)

  vname="it"
  vtype=NF90_int
  vdim2d=(/1,2/)
  call nciocv(filename,fid,vname,vtype,vdim2d)
  call nciowa(filename,fid,vname,'long_name','temperature_intp_flag')

  vname="is"
  vtype=NF90_int
  vdim2d=(/1,2/)
  call nciocv(filename,fid,vname,vtype,vdim2d)
  call nciowa(filename,fid,vname,'long_name','salinity_intp_flag')
  vname="ityp"
  vtype=NF90_int
  vdim1d=(/1/)
  call nciocv(filename,fid,vname,vtype,vdim1d)
  call nciowa(filename,fid,vname,'long_name','profile_type')

  vname="pvalid"
  vtype=NF90_int
  vdim2d=(/1,2/)
  call nciocv(filename,fid,vname,vtype,vdim2d)
  call nciowa(filename,fid,vname,'long_name','valid_flag')

  vname="qctype"
  vtype=NF90_int
  vdim1d=(/3/)
  call nciodd(filename,fid,vname,3)
  call nciocv(filename,fid,vname,vtype,vdim1d)
  call nciowa(filename,fid,vname,'long_name','qc_comparison_field_type')

  ! end define mode

  obsgrp=0
  obsgrp(l2_tsprofiles)=1

  call ncioed(filename,fid)
  call nciowv(filename,fid,"nprof",prof_num)
  call nciowv(filename,fid,"depth",zlevels)
  call nciowv(filename,fid,"obsgrp",obsgrp)
  call nciowv(filename,fid,"qctype",qctype)
  call nciowv(filename,fid,"plon",plon)
  call nciowv(filename,fid,"plat",plat)
  call nciowv(filename,fid,"ptime",ptime)
  call nciowv(filename,fid,"temp",temp)
  call nciowv(filename,fid,"saln",saln)
  call nciowv(filename,fid,"sctemp",sctemp)
  call nciowv(filename,fid,"scsaln",scsaln)
  call nciowv(filename,fid,"dctemp",dctemp)
  call nciowv(filename,fid,"dcsaln",dcsaln)
  call nciowv(filename,fid,"ctstd",ctstd)
  call nciowv(filename,fid,"csstd",csstd)
  call nciowv(filename,fid,"it",it)
  call nciowv(filename,fid,"is",is)
  call nciowv(filename,fid,"ityp",ityp)
  call nciowv(filename,fid,"pvalid",pvalid)


   call nciocl(filename,fid)

  end subroutine







